#include <bits/stdc++.h>

const int32_t MAX_N = 15 * 1e4;
const int32_t MAX_S = 75 * 1e3;
const int32_t MAX_T = 75 * 1e3;

struct Student {
    int32_t s, t, ind, group;

    bool operator< (Student &o) const {
        if(o.s != s) {
            return s < o.s;
        }
        return t < o.t;
    }
};

bool possibleS[MAX_S + 5], possibleT[MAX_T + 5];
Student v[MAX_N + 5];
std::vector< int32_t > groups[MAX_S + 5], sGroups[MAX_S + 5], tGroups[MAX_T + 5];

bool cmp_size(std::vector< int32_t > &x, std::vector< int32_t > &y) {
    return x.size() > y.size();
}

bool cmp_ind(const Student &x, const Student &y) {
    return x.ind < y.ind;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int32_t n, s, t;
    std::cin >> n >> s >> t;

    for(int32_t i = 0; i < n; i++) {
        std::cin >> v[i].s >> v[i].t;
        v[i].ind = i;
    }

    std::sort(v, v + n);

    int32_t groupId = 0;
    for(int32_t i = 0; i < n; i++) {
        if(i != 0 && v[i].s != v[i - 1].s) {
            groupId++;
        }

        groups[groupId].push_back(v[i].ind);
    }

    std::sort(v, v + n, cmp_ind);

    std::vector< std::pair< int32_t, int32_t > > aux;
    for(int32_t i = 0; i < groupId; i++) {
        int32_t last = -1;
        bool ok = true;
        for(auto &x : groups[i]) {
            if(last != -1 && v[x].t != last) {
                ok = false;
                break;
            }

            last = v[x].t;
        }

        if(ok) {
            aux.push_back({ last, i });
        }
    }

    std::sort(aux.begin(), aux.end());

    int32_t newGroupId = 0, par = aux[0].second;
    for(int32_t i = 1; i < aux.size(); i++) {
        if(aux[i].first == aux[i - 1].first) {
            for(auto &x : groups[aux[i].second]) {
                groups[par].push_back(x);
            }
            groups[aux[i].second].clear();
        }
        else {
            par = aux[i].second;
        }
    }

    std::sort(groups, groups + s, cmp_size);

    int32_t k;
    std::set< int32_t > an, bn, al, bl, am, bm;
    for(int32_t i = 0; i < s; i++) {
        if(groups[i].size() == 0) {
            k = i;
            break;
        }

        int32_t lastS = -1, lastT = -1;
        bool okS = true, okT = true;
        for(auto &x : groups[i]) {
            v[x].group = i;

            if(lastS != -1 && v[x].s != lastS) {
                okS = false;
            }
            if(lastT != -1 && v[x].t != lastT) {
                okT = false;
            }

            lastS = v[x].s;
            lastT = v[x].t;
        }

        if(okS) {
            al.insert(lastS);
            sGroups[lastS].push_back(i);
        }
        if(okT) {
            am.insert(lastT);
            tGroups[lastT].push_back(i);
        }

        /**
        for(auto &x : groups[i]) {
            std::cout << x << " ";
        }
        std::cout << '\n';
        */
    }

    for(int32_t i = 0; i < n; i++) {
        if(sGroups[v[i].s].size() >= 1 && sGroups[v[i].s][0] != v[i].group) {
            bn.insert(i);
        }
        if(sGroups[v[i].s].size() >= 2 && sGroups[v[i].s][1] != v[i].group) {
            bn.insert(i);
        }

        if(tGroups[v[i].t].size() >= 1 && tGroups[v[i].t][0] != v[i].group) {
            bn.insert(i);
        }
        if(tGroups[v[i].t].size() >= 2 && tGroups[v[i].t][1] != v[i].group) {
            bn.insert(i);
        }
    }

    for(int32_t i = 0; i < k; i++) {
        std::vector< int32_t > p;
        for(auto &x : groups[i]) {
            if(bn.find(x) == bn.end()) {
                possibleS[v[x].s] = true;
                possibleT[v[x].t] = true;
                p.push_back(x);
            }
        }

        if(p.size() == 1) {
            an.insert(p[0]);
        }
    }

    for(int32_t i = 1; i <= s; i++) {
        if(!possibleS[i]) {
            bl.insert(i);
        }
    }

    for(int32_t i = 1; i <= t; i++) {
        if(!possibleT[i]) {
            bm.insert(i);
        }
    }

    int32_t newK = 0;
    for(int32_t i = 0; i < k; i++) {
        for(auto &x : groups[i]) {
            if(bn.find(x) == bn.end()) {
                newK++;
                break;
            }
        }
    }

    std::cout << newK << " " << an.size() << " " << bn.size() << " " << al.size() << " " << bl.size() << " " << am.size() << " " << bm.size() << '\n';
    for(auto &x : an) {
        std::cout << x + 1 << " ";
    }
    std::cout << '\n';
    for(auto &x : bn) {
        std::cout << x + 1<< " ";
    }
    std::cout << '\n';
    for(auto &x : al) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bl) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : am) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bm) {
        std::cout << x << " ";
    }
    std::cout << '\n';
}
