#include <bits/stdc++.h>

const int32_t MAX_N = 15 * 1e4;
const int32_t MAX_S = 75 * 1e3;
const int32_t MAX_T = 75 * 1e3;

struct Student {
    int32_t s, t, ind, group;

    bool operator< (Student &o) const {
        if(o.s != s) {
            return s < o.s;
        }
        return t < o.t;
    }
};

bool possibleS[MAX_S + 5], possibleT[MAX_T + 5];
Student v[MAX_N + 5];
std::vector< int32_t > groups[MAX_S + 5], sGroups[MAX_S + 5], tGroups[MAX_T + 5];

bool possibleS1[MAX_S + 5], possibleT1[MAX_T + 5];
std::vector< int32_t > groups1[MAX_S + 5], sGroups1[MAX_S + 5], tGroups1[MAX_T + 5];

bool cmp_size(std::vector< int32_t > &x, std::vector< int32_t > &y) {
    return x.size() > y.size();
}

bool cmp_ind(const Student &x, const Student &y) {
    return x.ind < y.ind;
}

bool cmp_t(const Student &x, const Student &y) {
    return x.t < y.t;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int32_t n, s, t;
    std::cin >> n >> s >> t;

    for(int32_t i = 0; i < n; i++) {
        std::cin >> v[i].s >> v[i].t;
        v[i].ind = i;
    }

    std::sort(v, v + n);

    int32_t groupId = 0;
    for(int32_t i = 0; i < n; i++) {
        if(i != 0 && v[i].s != v[i - 1].s) {
            groupId++;
        }

        groups[groupId].push_back(v[i].ind);
    }

    std::sort(v, v + n, cmp_ind);

    std::vector< std::pair< int32_t, int32_t > > aux;
    for(int32_t i = 0; i < groupId; i++) {
        int32_t last = -1;
        bool ok = true;
        for(auto &x : groups[i]) {
            if(last != -1 && v[x].t != last) {
                ok = false;
                break;
            }

            last = v[x].t;
        }

        if(ok) {
            aux.push_back({ last, i });
        }
    }

    std::sort(aux.begin(), aux.end());

    if(aux.size() != 0) {
        int32_t par = aux[0].second;
        for(int32_t i = 1; i < aux.size(); i++) {
            if(aux[i].first == aux[i - 1].first) {
                for(auto &x : groups[aux[i].second]) {
                    groups[par].push_back(x);
                }
                groups[aux[i].second].clear();
            }
            else {
                par = aux[i].second;
            }
        }
    }

    std::sort(groups, groups + s, cmp_size);

    int32_t k = 0;
    std::set< int32_t > an, bn, al, bl, am, bm;
    for(int32_t i = 0; i < s; i++) {
        if(groups[i].size() == 0) {
            continue;
        }

        k++;

        int32_t lastS = -1, lastT = -1;
        bool okS = true, okT = true;
        for(auto &x : groups[i]) {
            v[x].group = i;

            if(lastS != -1 && v[x].s != lastS) {
                okS = false;
            }
            if(lastT != -1 && v[x].t != lastT) {
                okT = false;
            }

            lastS = v[x].s;
            lastT = v[x].t;
        }

        if(okS) {
            sGroups[lastS].push_back(i);
        }
        if(okT) {
            tGroups[lastT].push_back(i);
        }
    }

    for(int32_t i = 0; i < n; i++) {
        if(sGroups[v[i].s].size() >= 1 && sGroups[v[i].s][0] != v[i].group) {
            bn.insert(i);
        }
        if(sGroups[v[i].s].size() >= 2 && sGroups[v[i].s][1] != v[i].group) {
            bn.insert(i);
        }

        if(tGroups[v[i].t].size() >= 1 && tGroups[v[i].t][0] != v[i].group) {
            bn.insert(i);
        }
        if(tGroups[v[i].t].size() >= 2 && tGroups[v[i].t][1] != v[i].group) {
            bn.insert(i);
        }
    }

    for(int32_t i = 0; i < k; i++) {
        std::vector< int32_t > p;
        for(auto &x : groups[i]) {
            if(bn.find(x) == bn.end()) {
                possibleS[v[x].s] = true;
                possibleT[v[x].t] = true;
                p.push_back(x);
            }
        }

        if(p.size() == 1) {
            an.insert(p[0]);
        }
    }

    for(int32_t i = 1; i <= s; i++) {
        if(!possibleS[i]) {
            bl.insert(i);
        }
    }

    for(int32_t i = 1; i <= t; i++) {
        if(!possibleT[i]) {
            bm.insert(i);
        }
    }

    int32_t newK = 0;
    for(int32_t i = 0; i < k; i++) {
        for(auto &y : groups[i]) {
            if(bn.find(y) == bn.end()) {
                newK++;

                int32_t lastS = -1, lastT = -1;
                bool okS = true, okT = true;
                for(auto &x : groups[i]) {
                    if(bn.find(x) != bn.end()) {
                        continue;
                    }

                    if(lastS != -1 && v[x].s != lastS) {
                        okS = false;
                    }
                    if(lastT != -1 && v[x].t != lastT) {
                        okT = false;
                    }

                    lastS = v[x].s;
                    lastT = v[x].t;
                }

                if(okS) {
                    al.insert(lastS);
                }
                if(okT) {
                    am.insert(lastT);
                }

                break;
            }
        }
    }

    /// -------------------------------------------------------------------------

    for(int32_t i = 0; i < n; i++) {
        std::swap(v[i].s, v[i].t);
    }
    std::sort(v, v + n);

    std::swap(s, t);

    int32_t groupId1 = 0;
    for(int32_t i = 0; i < n; i++) {
        if(i != 0 && v[i].s != v[i - 1].s) {
            groupId1++;
        }

        groups1[groupId1].push_back(v[i].ind);
    }

    std::sort(v, v + n, cmp_ind);

    std::vector< std::pair< int32_t, int32_t > > aux1;
    for(int32_t i = 0; i < groupId1; i++) {
        int32_t last = -1;
        bool ok = true;
        for(auto &x : groups1[i]) {
            if(last != -1 && v[x].t != last) {
                ok = false;
                break;
            }

            last = v[x].t;
        }

        if(ok) {
            aux1.push_back({ last, i });
        }
    }

    std::sort(aux1.begin(), aux1.end());

    if(aux1.size() != 0) {
        int32_t par = aux1[0].second;
        for(int32_t i = 1; i < aux1.size(); i++) {
            if(aux1[i].first == aux1[i - 1].first) {
                for(auto &x : groups1[aux1[i].second]) {
                    groups1[par].push_back(x);
                }
                groups1[aux1[i].second].clear();
            }
            else {
                par = aux1[i].second;
            }
        }
    }

    std::sort(groups1, groups1 + s, cmp_size);

    int32_t k1 = 0;
    std::set< int32_t > an1, bn1, al1, bl1, am1, bm1;
    for(int32_t i = 0; i < s; i++) {
        if(groups1[i].size() == 0) {
            continue;
        }

        k1++;

        int32_t lastS = -1, lastT = -1;
        bool okS = true, okT = true;
        for(auto &x : groups1[i]) {
            v[x].group = i;

            if(lastS != -1 && v[x].s != lastS) {
                okS = false;
            }
            if(lastT != -1 && v[x].t != lastT) {
                okT = false;
            }

            lastS = v[x].s;
            lastT = v[x].t;
        }

        if(okS) {
            sGroups1[lastS].push_back(i);
        }
        if(okT) {
            tGroups1[lastT].push_back(i);
        }

        /**
        for(auto &x : groups[i]) {
            std::cout << x << " ";
        }
        std::cout << '\n';
        */
    }

    for(int32_t i = 0; i < n; i++) {
        if(sGroups1[v[i].s].size() >= 1 && sGroups1[v[i].s][0] != v[i].group) {
            bn1.insert(i);
        }
        if(sGroups1[v[i].s].size() >= 2 && sGroups1[v[i].s][1] != v[i].group) {
            bn1.insert(i);
        }

        if(tGroups1[v[i].t].size() >= 1 && tGroups1[v[i].t][0] != v[i].group) {
            bn1.insert(i);
        }
        if(tGroups1[v[i].t].size() >= 2 && tGroups1[v[i].t][1] != v[i].group) {
            bn1.insert(i);
        }
    }

    for(int32_t i = 0; i < k1; i++) {
        std::vector< int32_t > p;
        for(auto &x : groups1[i]) {
            if(bn1.find(x) == bn1.end()) {
                possibleS1[v[x].s] = true;
                possibleT1[v[x].t] = true;
                p.push_back(x);
            }
        }

        if(p.size() == 1) {
            an1.insert(p[0]);
        }
    }

    for(int32_t i = 1; i <= s; i++) {
        if(!possibleS1[i]) {
            bl1.insert(i);
        }
    }

    for(int32_t i = 1; i <= t; i++) {
        if(!possibleT1[i]) {
            bm1.insert(i);
        }
    }

    int32_t newK1 = 0;
    for(int32_t i = 0; i < k1; i++) {
        for(auto &y : groups1[i]) {
            if(bn1.find(y) == bn1.end()) {
                newK1++;

                int32_t lastS = -1, lastT = -1;
                bool okS = true, okT = true;
                for(auto &x : groups1[i]) {
                    if(bn1.find(x) != bn1.end()) {
                        continue;
                    }

                    if(lastS != -1 && v[x].s != lastS) {
                        okS = false;
                    }
                    if(lastT != -1 && v[x].t != lastT) {
                        okT = false;
                    }

                    lastS = v[x].s;
                    lastT = v[x].t;
                }

                if(okS) {
                    al1.insert(lastS);
                }
                if(okT) {
                    am1.insert(lastT);
                }

                break;
            }
        }
    }

    /**
    std::cout << newK << " " << an.size() << " " << bn.size() << " " << al.size() << " " << bl.size() << " " << am.size() << " " << bm.size() << '\n';
    for(auto &x : an) {
        std::cout << x + 1 << " ";
    }
    std::cout << '\n';
    for(auto &x : bn) {
        std::cout << x + 1<< " ";
    }
    std::cout << '\n';
    for(auto &x : al) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bl) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : am) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bm) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    */


    std::swap(al1, am1);
    std::swap(bl1, bm1);

    /**
    std::cout << newK1 << " " << an1.size() << " " << bn1.size() << " " << al1.size() << " " << bl1.size() << " " << am1.size() << " " << bm1.size() << '\n';
    for(auto &x : an1) {
        std::cout << x + 1 << " ";
    }
    std::cout << '\n';
    for(auto &x : bn1) {
        std::cout << x + 1<< " ";
    }
    std::cout << '\n';
    for(auto &x : al1) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bl1) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : am1) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bm1) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    */

    std::set< int32_t > an2, bn2, al2, bl2, am2, bm2;
    for(int32_t i = 0; i < n; i++) {
        if(an.find(i) != an.end() && an1.find(i) != an1.end()) {
            an2.insert(i);
        }
        if(bn.find(i) != bn.end() && bn1.find(i) != bn1.end()) {
            bn2.insert(i);
        }
    }

    for(int32_t i = 1; i <= s; i++) {
        if(al.find(i) != al.end() && al1.find(i) != al1.end()) {
            al2.insert(i);
        }
        if(bl.find(i) != bl.end() && bl1.find(i) != bl1.end()) {
            bl2.insert(i);
        }
    }

    for(int32_t i = 1; i <= s; i++) {
        if(am.find(i) != am.end() && am1.find(i) != am1.end()) {
            am2.insert(i);
        }
        if(bm.find(i) != bm.end() && bm1.find(i) != bm1.end()) {
            bm2.insert(i);
        }
    }

    std::cout << newK << " " << an2.size() << " " << bn2.size() << " " << al2.size() << " " << bl2.size() << " " << am2.size() << " " << bm2.size() << '\n';
    for(auto &x : an2) {
        std::cout << x + 1 << " ";
    }
    std::cout << '\n';
    for(auto &x : bn2) {
        std::cout << x + 1<< " ";
    }
    std::cout << '\n';
    for(auto &x : al2) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bl2) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : am2) {
        std::cout << x << " ";
    }
    std::cout << '\n';
    for(auto &x : bm2) {
        std::cout << x << " ";
    }
    std::cout << '\n';
}
