#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;

const int MAXN = 105;

int n;
long double X[MAXN], Y[MAXN], R[MAXN];
long double opt = 0;

void Init()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> X[i] >> Y[i] >> R[i];
    }
}

long double Dist(long double x1, long double y1, long double x2, long double y2)
{
    long double x = x1 - x2;
    long double y = y1 - y2;
    return sqrt(x * x + y * y);
}

long double Probe(long double x, long double y)
{
    long double l = 0, r = 1500, ans = 0, eps = 0.0000000001;
    while (r - l >= eps)
    {
        long double mid = (l + r) / 2;
        bool fl = true;
        for (int i = 1; i <= n; ++ i)
        {
            if (Dist(x, y, X[i], Y[i]) <= R[i] + mid)
            {
                fl = false;
                break;
            }
        }

        if (fl)
        {
            ans = mid;
            l = mid + eps;
        }
        else
        {
            r = mid - eps;
        }
    }

    return ans;
}

void MoveVertical()
{

}

void MoveHorizontal()
{

}

int main()
{
    Init();

    int ii, jj;
    for (int i = 0; i <= 1000; ++ i)
    {
        long double tek = Probe(i, 0);
        if (tek > opt)
        {
            opt = tek;
            ii = i;
            jj = 0;
        }
        tek = Probe(i, 1000);
        if (tek > opt)
        {
            opt = tek;
            ii = i;
            jj = 1000;
        }
    }

    for (int j = 0; j <= 1000; ++ j)
    {
        long double tek = Probe(0, j);
        if (tek > opt)
        {
            opt = tek;
            ii = 0;
            jj = j;
        }
        tek = Probe(1000, j);
        if (tek > opt)
        {
            opt = tek;
            ii = 1000;
            jj = j;
        }
    }

    printf("%.10Lf\n", opt);
    return 0;

}
