#include <iostream>
#include <set>
using namespace std;

const int MAXN = 100005;
const int MOD = 1000000009;
const int BASE = 29;

int n, q;
string s;

long long h[MAXN], p[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> s >> q;
    n = s.size();

    p[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        p[i] = (p[i - 1] * BASE) % MOD;
        cout << p[i] << endl;
    }
}

void pre_hash()
{
    for (int i = 0; i < n; ++ i)
    {
        h[i] = (s[i] - 'a' + 1) * p[i];
        h[i] %= MOD;
        if (i != 0) h[i] = (h[i] + h[i - 1]) % MOD;
    }
}

int get_hash(int l, int r)
{
    long long val = h[r];
    if (l != 0) val -= h[l - 1];

    if (val < 0) val += MOD;
    val = (val * p[n - l]) % MOD;
    return val;
}

int main()
{
    Init();
    pre_hash();

    set<int> mn;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = i; j < n; ++ j)
        {
            //cout << i << ' ' << j << ' ' << get_hash(i, j) << endl;
            mn.insert(get_hash(i, j));
        }
    }

    cout << mn.size() << endl;
    return 0;
}

