#include <iostream>
#include <set>
using namespace std;

const int MAXN = 100005;

const int MOD1 = 1000000007;
const int MOD2 = 1000000009;
const int BASE1 = 29;
const int BASE2 = 31;

int n, q;
string s;

long long h[MAXN][2], p[MAXN][2];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> s >> q;
    n = s.size();

    p[0][0] = 1;
    p[0][1] = 1;
    for (int i = 1; i < MAXN; ++ i)
    {
        p[i][0] = (p[i - 1][0] * BASE1) % MOD1;
        p[i][1] = (p[i - 1][1] * BASE2) % MOD2;
    }
}

void pre_hash()
{
    for (int i = 0; i < n; ++ i)
    {
        h[i][0] = (s[i] - 'a' + 1) * p[i][0];
        h[i][0] %= MOD1;
        if (i != 0) h[i][0] = (h[i][0] + h[i - 1][0]) % MOD1;
    }
    for (int i = 0; i < n; ++ i)
    {
        h[i][1] = (s[i] - 'a' + 1) * p[i][1];
        h[i][1] %= MOD2;
        if (i != 0) h[i][1] = (h[i][1] + h[i - 1][1]) % MOD2;
    }
}

pair<int, int> get_hash(int l, int r)
{
    long long val1 = h[r][0], val2 = h[r][1];
    if (l != 0) val1 -= h[l - 1][0];
    if (l != 0) val2 -= h[l - 1][1];

    if (val1 < 0) val1 += MOD1;
    if (val2 < 0) val2 += MOD2;
    val1 = (val1 * p[n - l][0]) % MOD1;
    val2 = (val2 * p[n - l][1]) % MOD2;
    return {val1, val2};
}

int main()
{
    Init();
    pre_hash();

    set<pair<int, int>> mn;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = i; j < n; ++ j)
        {
            //cout << i << ' ' << j << ' ' << get_hash(i, j) << endl;
            mn.emplace(get_hash(i, j));
        }
    }

    cout << mn.size() << endl;
    return 0;
}

