#include<bits/stdc++.h>
using namespace std;
const int nmax=3e5+42;

pair<int,int> edges[nmax];

int n,s,t;

bool blocked[nmax];

vector<int/*edge id*/> adj[nmax];

int source,sink;

struct edge
{
    int to,flow;
};

edge info[nmax*5];
int pointer=0;

bool been[nmax];

int dist[nmax];

queue< pair<int/*node*/,int/*d*/> > q;

void bfs()
{
    for(int i=source;i<=sink;i++)dist[i]=-1;

    q.push({source,0});

    while(q.size())
    {
        pair<int/*node*/,int/*d*/> cur=q.front();
        q.pop();

        if(dist[cur.first]!=-1||blocked[cur.first])continue;

        dist[cur.first]=cur.second;

        for(auto k:adj[cur.first])
            if(info[k].flow&&dist[info[k].to]==-1)q.push({info[k].to,cur.second+1});
    }
}

void add_edge(int from,int to)
{
    info[pointer].to=to;
    info[pointer].flow=1;
    adj[from].push_back(pointer);

    pointer++;
    info[pointer].to=from;
    info[pointer].flow=0;
    adj[to].push_back(pointer);

    pointer++;
}
bool dfs(int node)
{
    if(been[node]||blocked[node])return 0;

    if(node==sink)return 1;

    //cout<<"dfs "<<node<<" "<<dist[node]<<endl;
    //for(int i=source;i<=sink;i++)cout<<been[i]<<" ";cout<<endl;

    for(auto k:adj[node])
        if(dist[node]+1==dist[info[k].to]&&info[k].flow)
            if(dfs(info[k].to))
        {
            //cout<<"path "<<node<<endl;

            info[k].flow--;
            info[k^1].flow++;
            return 1;
        }
    been[node]=1;
    return 0;
}

bool blocked_edge[nmax];

pair<int,int> ban;

int flow(bool student)
{
    pointer=0;
    for(int i=source;i<=sink;i++)adj[i]={};

    source=0;
    sink=s+t+n+1;

    for(int i=1;i<=s;i++)
        if(ban.first!=i)add_edge(source,i);

    for(int i=1;i<=t;i++)
        if(ban.second!=s+i)add_edge(s+i,sink);

    for(int i=1;i<=n;i++)
        if(blocked_edge[i]==0)
        {
            add_edge(edges[i].first,s+t+i);
            add_edge(s+t+i,edges[i].second);
        }
        else if(ban.first&&student==0)
        {
            add_edge(s+t+i,edges[i].first);
            add_edge(edges[i].second,s+t+i);
        }

    int f=0;

    while(1)
    {
        //cout<<"bfs "<<" "<<sink<<endl;
        bfs();

        if(dist[sink]==-1)break;

        for(int i=source;i<=sink;i++)been[i]=0;

        while(dfs(source))f++;
        //cout<<"f= "<<f<<endl;
        //system("pause");
    }
    return f;
}


void print(vector<int> cur)
{
    for(auto k:cur)printf("%i ",k);printf("\n");
}
int main()
{
    scanf("%i%i%i",&n,&s,&t);

    for(int i=1;i<=n;i++)
    {
        scanf("%i%i",&edges[i].first,&edges[i].second);
        edges[i].second+=s;
    }

    int mem=flow(0);

    printf("%i",mem);

    vector<int> always_first={},never_first={};

    for(int i=1;i<=s;i++)
    {
        ban={0,0};

        blocked[i]=1;

        if(flow(0)!=mem)always_first.push_back(i);

        blocked[i]=0;

        int to_test=-1;

        for(int j=1;j<=n;j++)
            if(edges[j].first==i)
            {
                blocked_edge[j]=1;
                to_test=j;

                ban={edges[j].first,edges[j].second};

                break;
            }

        if(to_test==-1)never_first.push_back(i);
        else
        {
            if(flow(0)+1!=mem)never_first.push_back(i);

            blocked_edge[to_test]=0;
        }
    }




    vector<int> always_student={},never_student={};

    for(int i=1;i<=n;i++)
    {
        ban={0,0};

        blocked[s+t+i]=1;

        if(flow(0)!=mem)always_student.push_back(i);

        blocked[s+t+i]=0;

        ban={edges[i].first,edges[i].second};

        blocked_edge[i]=1;

        if(flow(1)+1!=mem)never_student.push_back(i);

        blocked_edge[i]=0;
    }



    vector<int> always_second={},never_second={};

    for(int i=1;i<=t;i++)
    {
        ban={0,0};

        blocked[s+i]=1;

        if(flow(0)!=mem)always_second.push_back(i);

        blocked[s+i]=0;

        int to_test=-1;

        for(int j=1;j<=n;j++)
            if(edges[j].second==i+s)
            {
                blocked_edge[j]=1;
                to_test=j;

                ban={edges[j].first,edges[j].second};

                break;
            }

        if(to_test==-1)never_second.push_back(i);
        else
        {
            if(flow(0)+1!=mem)never_second.push_back(i);

            blocked_edge[to_test]=0;
        }
    }




    printf(" %i %i %i %i %i %i\n",always_student.size(),never_student.size(),always_first.size(),never_first.size(),always_second.size(),never_second.size());

    print(always_student);

    print(never_student);

    print(always_first);

    print(never_first);

    print(always_second);

    print(never_second);
    return 0;
}
