#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <cstdlib>
#include <cmath>
using namespace std;

typedef pair<double, double> point;

static inline double dist_sq (point a, point b)
{
    double x = b.first  - a.first ;
    double y = b.second - a.second;
    return x*x+y*y;
}

static inline double dist (point a, point b)
{
    return sqrt(dist_sq(a, b));
}

struct circle
{
    point c;
    double r;
};

circle c1, c2;

double test_point (point p)
{
    double d1 = dist(p, c1.c);
    double d2 = dist(p, c2.c);
    d1 -= c1.r;
    d2 -= c2.r;
    return min(d1, d2);
}

#define DELTA 0.00003

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;

    if(n!=2)
        abort();

    cin>>c1.c.first>>c1.c.second>>c1.r;
    cin>>c2.c.first>>c2.c.second>>c2.r;
}

double solve()
{
    double res=0;

    for(double i=0; i<=1000.0; i+=DELTA)
    {
        res = max(res, test_point(make_pair(0.0, i)));
    }

    for(double i=0; i<=1000.0; i+=DELTA)
    {
        res = max(res, test_point(make_pair(i, 0.0)));
    }

    for(double i=0; i<=1000.0; i+=DELTA)
    {
        res = max(res, test_point(make_pair(1000.0, i)));
    }

    for(double i=0; i<=1000.0; i+=DELTA)
    {
        res = max(res, test_point(make_pair(i, 1000.0)));
    }

    return res;
}

int main()
{
    init();

    cout<<fixed;
    cout.precision(10);
    cout<<solve()<<endl;

    return 0;
}
