#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cstdint>

using namespace std;

uint32_t n, s, t;

struct student
{
    uint32_t  e, i;
};

vector <student> students;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin>>n>>s>>t;

    if(n>10 || s>5 || t>5)
        abort();

    students.resize(n);
    for(uint32_t i=0; i<n; i++)
    {
        cin>>students[i].e>>students[i].i;
        students[i].e--;
        students[i].i--;
    }
}

uint32_t req_len;

uint32_t find_req_len()
{
    uint32_t used_e, used_i, cur_br, res_br=0;

    for(uint32_t i=0; i<=((1<<n)-1); i++)
    {
        used_e=0; used_i=0; cur_br=0;
        bool is_ok = true;

        for(uint32_t j=0; j<n; j++)
        {
            uint32_t bitmask = (1<<j);
            if( (i & bitmask) > 0)
            {
                uint32_t bitmask_e = (1<<(students[j].e));
                uint32_t bitmask_i = (1<<(students[j].i));
                if( (used_i & bitmask_i) == 0 && (used_e & bitmask_e) ==0 )
                {
                    used_e |= bitmask_e;
                    used_i |= bitmask_i;
                    cur_br++;
                }
                else
                {
                    is_ok = false;
                    break;
                }
            }
        }

        if(is_ok)
            res_br = max(res_br, cur_br);
    }

    return res_br;
}

void show_bitmask (uint32_t a)
{
    for(uint32_t i=0; i<=a; i++)
    {
        if(a & (1<<i))
        {
            cout<<i+1<<' ';
        }
    }
    cout<<endl;
}

void solve(uint32_t req_len)
{
    uint32_t used_e, used_i;

    uint32_t  always_in  =((1<<n)-1), always_out  =((1<<n)-1);
    uint32_t  always_in_e=((1<<s)-1), always_out_e=((1<<s)-1);
    uint32_t  always_in_i=((1<<t)-1), always_out_i=((1<<t)-1);

    for(uint32_t i=0; i<=((1<<n)-1); i++)
    {
        if(__builtin_popcount(i)!=req_len)
            continue;

        used_e=0; used_i=0;
        bool is_ok=true;

        for(uint32_t j=0; j<n; j++)
        {
            uint32_t bitmask = (1<<j);
            if( (i & bitmask) > 0)
            {
                uint32_t bitmask_e = (1<<(students[j].e));
                uint32_t bitmask_i = (1<<(students[j].i));
                if( (used_i & bitmask_i) == 0 && (used_e & bitmask_e) ==0 )
                {
                    used_e |= bitmask_e;
                    used_i |= bitmask_i;
                }
                else
                {
                    is_ok = false;
                    break;
                }
            }
        }

        if(is_ok)
        {
            always_out &= (~i);
            always_in  &=   i;

            always_out_e &= (~used_e);
            always_in_e  &=   used_e;

            always_out_i &= (~used_i);
            always_in_i  &=   used_i;
        }
    }

//    cout<<always_in<<endl;
//    cout<<always_out<<endl;

    cout<<req_len<<' '
        <<__builtin_popcount(always_in  )<<' '<<__builtin_popcount(always_out  )<<' '
        <<__builtin_popcount(always_in_e)<<' '<<__builtin_popcount(always_out_e)<<' '
        <<__builtin_popcount(always_in_i)<<' '<<__builtin_popcount(always_out_i)<<endl;

    show_bitmask(always_in  );
    show_bitmask(always_out  );
    show_bitmask(always_in_e);
    show_bitmask(always_out_e);
    show_bitmask(always_in_i);
    show_bitmask(always_out_i);
}

int main()
{
    init();

    req_len = find_req_len();

//    cout<<req_len<<endl;

    solve(req_len);

    return 0;
}
