#include<bits/stdc++.h>

typedef long double ld;
typedef std::pair<ld,ld> vec2;

#define EPSILON 0.3
#define PLANK 0.00000000001
#define SMOOTH 0.0001

using namespace std;

ld len(vec2 v){
  return sqrt(v.first*v.first + v.second * v.second);
}

vec2 add(vec2 a, vec2 b){
  return vec2(a.first - b.first, a.second - b.second);
}

vec2 move(vec2 a, vec2 b){
  return vec2(a.first + b.first, a.second + b.second);
}

ld sdDisk(vec2 p, ld rad){
  return len(p) - rad;
}

ld smin(ld a, ld b, ld k)
{
  ld h = 0.5 + 0.5*(a-b)/k;
  h = h<0.0 ? 0.0 : (h>1.0 ? 1.0 : h);
  return b*h+a*(1.0-h) - k*h*(1.0-h);
}

int n;
vec2 coords[100];
ld rads[100];


ld sdScene(vec2 p){
  ld min = sdDisk(add(p,coords[0]),rads[0]);
  for (int i=1; i<n; i++)
    min = smin(min, sdDisk(add(p,coords[i]),rads[i]),SMOOTH);
  return min;
}

vec2 estimateNormal(vec2 p){
  return vec2(sdScene(vec2(p.first+EPSILON,p.second))-sdScene(vec2(p.first-EPSILON,p.second)),
              sdScene(vec2(p.first,p.second+EPSILON))-sdScene(vec2(p.first,p.second-EPSILON)));
}


int main(){
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin>>n;

  for(int i=0; i<n; i++){
    ld k,p,j;
    cin>>k>>p>>j;
    coords[i] = vec2(k,p);
    rads[i] = j;
  }

  ld max = 0;
  vec2 anchor;
  for(int i=0;i<1001;i++)
    for(int j=0;j<1001;j++)
      {
        ld curr = sdScene(vec2(i,j));
        if(max<curr)
          {
            max = curr;
            anchor = vec2(i,j);
          }
      }

  vec2 normal = vec2(0,0);

  do{
    anchor = move(anchor,normal);
    normal = estimateNormal(anchor);
  }while(normal.first>=PLANK && normal.second >= PLANK);

  cout<<setprecision(15)<<sdScene(anchor)<<endl;

  return 0;
}

/*
7
42.1337 13.666 191.17
543.21 765.432 55.555
987.987 666.666 321.321
0 1000 100
666.666 66.66 16.6
133.331 666.666666666 123.321
888.8 88.8 8.8
 */
