#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <map>
#define pb push_back
#define eb push_back
#define all(x) x.begin,x.end()
#define sz(x) ((int)x.size())
#define f first
#define s second

#pragma GCC optimize ("O3")
#pragma GCC target ("sse2")
#pragma GCC optimize ("unroll-loops")

using namespace std;

const int MAXN = 2e5;
int n, s, t;
struct edge {
    int fr, to; 
    vector<int> stud;
    int cap;
};
int beg, last;
int nume = 0;
edge e[3*MAXN];
pair<int, int> path[3*MAXN], path2[3*MAXN];
vector<pair<int, int>> con[3*MAXN];
map<pair<int, int>, int> mp;
int mxfl;
set<int> a[3], b[3];
int kr[MAXN];
int use[3*MAXN], usern[3*MAXN];

void addEdge(int u, int v, vector<int> st) {
    con[u].pb({v, nume});
    e[nume++] = {u, v, st, 1};
    con[v].pb({u, nume});
    e[nume++] = {v, u, st, 0};
}

void input() {
    int l, m;
    cin>>n>>s>>t;
    beg = 0, last = 3*MAXN-1;
    for (int i=1; i<=s; i++) {
        addEdge(0, i, {});
    }
    for (int i=1+s; i<=t+s; i++) {
        addEdge(i, last, {});
    }
    for (int i=0; i<n; i++) {
        cin>>l>>m;
        kr[i] = nume;
        if (mp.find({l, m}) == mp.end()) {
            mp[make_pair(l, m)] = nume;
            addEdge(l, m+s, {i+1});
        } else {
            e[mp[make_pair(l, m)]].stud.pb(i+1);
        }
    }
}

void output() {
    cout<<mxfl<<' ';
    for (int i=0; i<3; i++) {
        cout<<sz(a[i])<<' '<<sz(b[i])<<' ';
    }
    cout<<endl;
    for (int i=0; i<3; i++) {
        for (auto t : a[i]) {
            cout<<t<<' ';
        }
        cout<<'\n';
        for (auto t : b[i]) {
            cout<<t<<' ';
        }
        cout<<'\n';
    }
}

bool bfs() {
    queue<int> q;
    q.push(beg);
    
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        
        for (auto v : con[u]) {
            if (!e[v.s].cap || path[v.f].f != -1) {
                continue;
            }
            path[v.f] = {u, v.s};
            if (v.f == last) {
                return true;
            }
            q.push(v.f);
        }
    }
    return false;
}

bool revbfs() {
    queue<int> q;
    q.push(beg);
    
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        
        for (auto v : con[u]) {
            if (e[v.s].cap || path[v.f].f != -1) {
                continue;
            }
            path[v.f] = {u, v.s};
            if (v.f == last) {
                return true;
            }
            q.push(v.f);
        }
    }
    return false;
}

void zeroPath() {
    for (int i=0; i<3*MAXN; i++) {
        path[i] = {-1, -1};
    }
}

void zeroFlow() {
    for (int i=0; i<nume; i+=2) {
        e[i].cap = 1;
        e[i^1].cap = 0;
    }
    for (int i=0; i<nume; i++) {
        if (use[i]) {
            e[i].cap = 0;
        }
    }
}

void notZero() {
    for (int i=0; i<nume; i+=2) {
        if (use[i]) {
            e[i].cap = 1;
        }
    }
}

void zeroFlowLang() {
    for (int i=0; i<nume; i+=2) {
        e[i].cap = 1;
        e[i^1].cap = 0;
    }
    for (auto t : a[1]) {
        e[(t-1)*2].cap = 0;
        e[(t-1)*2+1].cap = 0;
    }
}

void notZeroLang() {
    for (auto t : a[1]) {
        e[(t-1)*2].cap = 1;
        e[(t-1)*2+1].cap = 0;
    }
}

void zeroFlowMus() {
    for (int i=0; i<nume; i+=2) {
        e[i].cap = 1;
        e[i^1].cap = 0;
    }
    for (auto t : a[2]) {
        e[2*s+2*n+(t-1)*2].cap = 0;    
    }
}

void notZeroMus() {
    for (auto t : a[2]) {
        e[2*s+2*n+(t-1)*2].cap = 1;    
    }
}

bool update() {
    for (auto t : con[beg]) {
        if (!e[t.s^1].cap) {
            a[1].erase(t.f);
        } else {
            b[1].erase(t.f);
        }
    }
    for (auto t : con[last]) {
        if (e[t.s^1].cap) {
            a[2].erase(t.f - s);
        } else {
            b[2].erase(t.f - s);
        }
    }
    bool nw = 0;
    for (int i=0; i<nume; i+=2) {
        if (usern[i] && !use[i]) {
            //cerr<<"one "<<e[i].stud[0]<<endl;
            nw = 1;
            use[i] = 1;
        }
        else if (!usern[i] && use[i] == 1) {
            //cerr<<"more "<<e[i].stud[0]<<endl;
            use[i] = 2;
        }
        usern[i] = 0;
    }
    return nw;
}

bool updateLang() {
    bool nw = 0;
    for (auto t : con[beg]) {
        if (!e[t.s^1].cap) {
            auto id = a[1].find(t.f);
            if (id != a[1].end()) {
                nw = 1;
                a[1].erase(id);
            }
        } else {
            b[1].erase(t.f);
        }
    }
    for (auto t : con[last]) {
        if (e[t.s^1].cap) {
            a[2].erase(t.f - s);
        } else {
            b[2].erase(t.f - s);
        }
    }
    for (int i=0; i<nume; i+=2) {
        if (usern[i] && !use[i]) {
            //cerr<<"one "<<e[i].stud[0]<<endl;
            nw = 1;
            use[i] = 1;
        }
        else if (!usern[i] && use[i] == 1) {
            //cerr<<"more "<<e[i].stud[0]<<endl;
            use[i] = 2;
        }
        usern[i] = 0;
    }
    return nw;
}

bool updateMus() {
    for (auto t : con[beg]) {
        if (!e[t.s^1].cap) {
            a[1].erase(t.f);
        } else {
            b[1].erase(t.f);
        }
    }
    bool nw = 0;
    for (auto t : con[last]) {
        if (e[t.s^1].cap) {
            auto id = a[2].find(t.f-s);
            if (id != a[2].end()) {
                nw = 1;
                a[2].erase(id);
            }
        } else {
            b[2].erase(t.f - s);
        }
    }
    for (int i=0; i<nume; i+=2) {
        if (usern[i] && !use[i]) {
            //cerr<<"one "<<e[i].stud[0]<<endl;
            nw = 1;
            use[i] = 1;
        }
        else if (!usern[i] && use[i] == 1) {
            //cerr<<"more "<<e[i].stud[0]<<endl;
            use[i] = 2;
        }
        usern[i] = 0;
    }
    return nw;
}

int flow() {
    int fl = 0;
    zeroPath();
    while (bfs()) {
        fl++;
        int curr = last;
        while (curr != beg) {
            //cerr<<curr<<' ';
            e[path[curr].s].cap--;
            e[path[curr].s^1].cap++;
            if (e[path[curr].s].stud.size()) {
                if (e[path[curr].s].fr <= s) {
                    usern[path[curr].s] = 1;
                } else {
                    usern[path[curr].s^1] = 0;
                }
            }
            curr = path[curr].f;
        }
        //cerr<<endl;
        zeroPath();
    }
    return fl;
}

void solve() {
    for (int i=1; i<=s; i++) {
        a[1].insert(i);
        b[1].insert(i);
    }
    for (int i=1; i<=t; i++) {
        a[2].insert(i);
        b[2].insert(i);
    }
    
    mxfl = flow();
    update();
    /*output();
    cerr<<endl;*/
    
    while (true) {
        zeroFlow();
        int currfl;
        currfl = flow();
        notZero();
        currfl += flow();  
        if (currfl < mxfl) {
            break;
        }      
        if (!update()) {
            break;
     
        }
    }
    
    while (true) {
        zeroFlowLang();
        int currfl;
        //cerr<<"pnow"<<endl;
        currfl = flow();
        //cerr<<"now "<<currfl<<endl;
        notZeroLang();
        currfl += flow();
        if (currfl < mxfl) {
            break;
        }      
        if (!updateLang()) {
            break;
        }
    }
    
    while (true) {
        zeroFlowMus();
        int currfl;
        //cerr<<"pnow"<<endl;
        currfl = flow();
        //cerr<<"now "<<currfl<<endl;
        notZeroMus();
        currfl += flow();
        if (currfl < mxfl) {
            break;
        }      
        if (!updateMus()) {
            break;
        }
    }
    
    for (int i=0; i<nume; i+=2) {
        if (use[i] == 0) {
            for (auto t : e[i].stud) {
                b[0].insert(t);
            }
        } else if (use[i] == 1) {
            if (e[i].stud.size() == 1) {
                a[0].insert(e[i].stud[0]);
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}
/*
6 4 5
1 1
2 1
3 2
3 3
3 4
4 4

4 3 2
1 1
2 1
2 2
3 2

4 2 3
1 1
1 2
2 2
2 3
*/