#include <bits/stdc++.h>

using namespace std;

const int k_N = 100 + 3;
const long double eps = 1e-10;
const long double k_Inf = 1e4;

int n;
array<long double, 3> circles[k_N];

long double sq(long double x){
    return x * x;
}

pair<bool, long double> check(long double c, bool w, long double mid){
    sort(circles, circles + n, [w](auto l, auto r){
         return l[!w] < r[!w];
    });

    vector<pair<long double, bool>> sweep_line;
    for(int i = 0; i < n; ++i){
        long double t = sq(mid + circles[i][2]) - sq(c - circles[i][w]);
        if(t > 0){
            t = sqrt((long double)t);
            //cout << t << " t" << endl;
            sweep_line.push_back({circles[i][!w] - t + eps, false});
            sweep_line.push_back({circles[i][!w] + t, true});
        }
    }

    int cnt = 0;
    long double prev_neg = 0;
    sort(sweep_line.begin(), sweep_line.end());
    for(int i = 0; i < sweep_line.size(); ++i){
        if(cnt >= 0 && (sweep_line[i].first - prev_neg) > 0){
            //cout << i << " i" << endl;
            //cout << sweep_line[i].first << " - " << prev_neg << endl;
            return {true, sweep_line[i].first};
        }

        if(sweep_line[i].second){
            if(cnt < 0)
                prev_neg = sweep_line[i].first;
            cnt++;
        }
        else{
            cnt--;
        }
    }

    //cout << prev_neg << " prev_neg" << endl;

    if(cnt >= 0 && ((long double)1000 - prev_neg) >= eps){
        //cout << "why" << endl;
        return {true, 1000};
    }

    return {false, 0};
}

pair<long double, long double> get_best(long double c, bool w){
    long double l = 0, r = k_Inf;
    while(abs(r - l) > eps){
        long double mid = (l + r) / 2;
        if(check(c, w, mid).first)
            l = mid;
        else
            r = mid;
    }

    pair<long double, long double> answer;
    answer.first = l;
    answer.second = check(c, w, l).second;
    return answer;
}

long double curr_c = 300;
long double best_c = 300, answer = 0;
bool best_w = false;
bool w = false;

void do_couple_of_iterations(long double value, int cnt){
    curr_c = value;
    w = false;
    for(int i = 0; i < cnt; ++i){
        auto p = get_best(curr_c, w);
        if(p.first > answer){
            answer = p.first;
            best_c = curr_c;
            best_w = w;
        }
        w = !w;
        curr_c = p.second;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < 3; ++j)
            cin >> circles[i][j];

    mt19937 mt(100);

    for(int i = 0; i < 50; ++i)
        do_couple_of_iterations((long double)(mt() % 10001) / (long double)10.0, 4);

    for(int i = -1000; i < 1000; ++i){
        auto p = get_best(best_c + (long double)i * (long double)0.0001, w);
        answer = max(p.first, answer);
    }

    if(answer < 0)
        answer = 0;

    cout << fixed << setprecision(10) << answer << "\n";
}
