#include <bits/stdc++.h>

using namespace std;

const int k_N = 1e5 + 3;
const int k_Log_N = 20;
const int k_A = 256;

struct SuffixArray{
    int n, log_n;
    int cnt[k_A], p[k_N], pn[k_N];
    int c[k_Log_N][k_N];

    void init(const string &s){
        n = (int)s.size();
        log_n = 0;

        fill(cnt, cnt + k_A, 0);

        for(int i = 0; i < n; ++i)
            cnt[s[i]]++;
        for(int i = 1; i < k_A; ++i)
            cnt[i] += cnt[i - 1];
        for(int i = n - 1; i >= 0; --i)
            p[--cnt[s[i]]] = i;

        int classes = 1;
        c[0][p[0]] = 0;

        for(int i = 1; i < n; ++i){
            if(s[p[i]] != s[p[i - 1]])
                classes++;
            c[0][p[i]] = classes - 1;
        }

        for(int h = 1, step = 1; h < n; h <<= 1, ++step){
            log_n = step;

            for(int i = 0; i < n; ++i){
                pn[i] = p[i] - h;
                if(pn[i] < 0)
                    pn[i] += n;
            }

            fill(cnt, cnt + classes, 0);

            for(int i = 0; i < n; ++i)
                cnt[c[step - 1][pn[i]]]++;
            for(int i = 1; i < n; ++i)
                cnt[i] += cnt[i - 1];
            for(int i = n - 1; i >= 0; --i)
                p[--cnt[c[step - 1][pn[i]]]] = pn[i];

            classes = 1;
            c[step][p[0]] = 0;

            for(int i = 1; i < n; ++i){
                pair<int, int> current{c[step - 1][p[i]], c[step - 1][(p[i] + h) % n]};
                pair<int, int> previous{c[step - 1][p[i - 1]], c[step - 1][(p[i - 1] + h) % n]};
                if(previous != current)
                    classes++;
                c[step][p[i]] = classes - 1;
            }
        }
    }

    int& operator[](int index){
        return p[index];
    }

    int lcp(int i, int j){
        i = p[i];
        j = p[j];

        int answer = 0;
        for(int k = log_n; k >= 0; --k){
            if(c[k][i] == c[k][j]){
                answer += (1 << k);
                i += (1 << k);
                j += (1 << k);
            }
        }

        return answer;
    }
};

string s;
SuffixArray suffix_array;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> s;
    s += "#";
    suffix_array.init(s);

    long long sum = 0;
    for(int i= 0; i < (int)s.size() - 1; ++i)
        sum += suffix_array.lcp(i, i + 1);

    long long n = (int)s.size() - 1;
    long long answer = n * (n + 1) / 2 - sum;

    cout << answer << "\n";
}
