#include <iostream>
#include <vector>

using namespace std;

int n, langs, musics;
pair < int , int > input [150000];
int langs_used [75000];
int music_used [75000];

bool is_possible (int team_size, int last_member = -1)
{
    //cout << team_size << " " << last_member << endl;
    if (team_size == 0)
    {
        return true;
    }
    for (int i = last_member + 1 ; i < n ; i ++)
        if (!langs_used [input [i].first] and !music_used [input [i].second])
        {
            langs_used [input [i].first] = music_used [input [i].second] = true;
            if (is_possible (team_size - 1, i))
            {
                langs_used [input [i].first] = music_used [input [i].second] = false;
                return true;
            }
            langs_used [input [i].first] = music_used [input [i].second] = false;
        }
    return false;
}

vector < int > solution;
vector < vector < int > > solutions;

void all_solutions (int team_size, int last_member)
{
    if (team_size == 0)
    {
        if (solutions.empty ())
        {
            solutions.push_back (solution);
            return;
        }
        else if (solution.size () > solutions [0].size ())
        {
            solutions = {solution};
            return;
        }
        else if (solution.size () == solutions [0].size ())
        {
            solutions.push_back (solution);
            return;
        }
        else
            return;
    }
    for (int i = last_member + 1 ; i < n ; i ++)
        if (!langs_used [input [i].first] and !music_used [input [i].second])
        {
            solution.push_back (i);
            langs_used [input [i].first] = music_used [input [i].second] = true;
            all_solutions (team_size - 1, i);
            langs_used [input [i].first] = music_used [input [i].second] = false;
            solution.pop_back ();
        }
}

int people_used [150000];

void print ()
{
    for (auto& x : solutions)
    {
        for (auto& y : x)
        {
            people_used [y] ++;
            langs_used [input [y].first] ++;
            music_used [input [y].second] ++;
        }
    }
    vector < int > always [3], never [3];
    for (int i = 0 ; i < n ; i ++)
    {
        if (people_used [i] == solutions.size ())
            always [0].push_back (i);
        if (people_used [i] == 0)
            never [0].push_back (i);
    }
    for (int i = 0 ; i < langs ; i ++)
    {
        if (langs_used [i] == solutions.size ())
            always [1].push_back (i);
        if (langs_used [i] == 0)
            never [1].push_back (i);
    }
    for (int i = 0 ; i < musics ; i ++)
    {
        if (music_used [i] == solutions.size ())
            always [2].push_back (i);
        if (music_used [i] == 0)
            never [2].push_back (i);
    }
    cout << solutions [0].size () << " ";
    cout << always [0].size () << " ";
    cout << never [0].size () << " ";
    cout << always [1].size () << " ";
    cout << never [1].size () << " ";
    cout << always [2].size () << " ";
    cout << never [2].size () << "\n";
    for (int i = 0 ; i < 3 ; i ++)
    {
        for (auto& x : always [i])
            cout << x + 1 << " ";
        cout << endl;
        for (auto& x : never [i])
            cout << x + 1<< " ";
        cout << endl;
    }
}

void solve ()
{
    int Min = 1, Max = min(n, min (langs, musics)) + 1;
    while (Min + 1 < Max)
    {
        //cout << "[" << min << ", " << max << ")" << endl;
        int mid = (Min + Max) / 2;
        if (is_possible (mid))
        {
            Min = mid;
        }
        else
            Max = mid;
    }
    all_solutions (Min, -1);
    print ();
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    cin >> n >> langs >> musics;
    for (int i = 0 ; i < n ; i ++)
    {
        cin >> input [i].first >> input [i].second;
        input [i].first --;
        input [i].second --;
    }
    solve ();
    return 0;
}
