#include <bits/stdc++.h>
using namespace std;
int n, s, t, N, L, M;
vector <pair <int, int> > students;
struct edge{
    int to, c, rev, idx;
};
vector <edge> adj [150005];
void add_edge (int u, int v, int idx){
    adj [u].push_back ({v, 1, adj [v].size (), idx});
    adj [v].push_back ({u, 0, adj [u].size () - 1, idx});
}
int level [150005];
bool bfs (){
    for (int i = 0; i < n; i ++) level [i] = -1;
    level [s] = 0;
    queue <int> q;
    q.push (s);
    while (!q.empty ()){
        int u = q.front ();
        q.pop ();
        for (edge e : adj [u]){
            if (e.c > 0 && level [e.to] == -1){
                level [e.to] = level [u] + 1;
                q.push (e.to);
            }
        }
    }
    return level [t] != -1;
}
int start [150005];
int dfs (int u, int flow){
    if (u == t) return flow;
    int sz = adj [u].size ();
    for (; start [u] < sz; start [u] ++){
        edge &e = adj [u][start [u]];
        if (e.c == 0 || level [e.to] != level [u] + 1) continue;
        int curr_flow = min (flow, e.c);
        int back_flow = dfs (e.to, curr_flow);
        if (back_flow){
            e.c -= back_flow;
            adj [e.to][e.rev].c += back_flow;
            return back_flow;
        }
    }
    return 0;
}
bool Alm [150005], As [150005], Blm [150005], Bs [150005];
int bre [150005];
bool used [150005];
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> N >> L >> M;
	s = L + M;
	t = L + M + 1;
	n = L + M + 2;
	for (int i = 0; i < L; i ++) add_edge (s, i, -1);
	for (int i = 0; i < M; i ++) add_edge (L + i, t, -1);
	for (int i = 0; i < N; i ++){
        int u, v;
        cin >> u >> v;
        u --;
        v --;
        add_edge (u, v + L, i);
        students.push_back ({u, v});
	}
	int maxflow = 0;
	while (bfs ()){
	    int f;
        do{
            for (int i = 0; i < n; i ++) start [i] = 0;
            f = dfs (s, 1000000000);
            maxflow += f;
        } while (f);
	}
	for (int u = 0; u <= L + M; u ++){
        if (level [u] == -1) continue;
        for (edge e : adj [u]){
            if (u != s && e.to < L) continue;
            if (level [e.to] == -1){
                if (u != s) Alm [u] = 1;
                if (e.to != t) Alm [e.to] = 1;
            }
        }
	}
	for (int i = 0; i < n; i ++) adj [i].clear ();
	for (int i = 0; i < L; i ++) add_edge (i, t, -1);
	for (int i = 0; i < M; i ++) add_edge (s, i + L, -1);
	for (int i = 0; i < N; i ++){
        auto p = students [i];
        add_edge (L + p.second, p.first, i);
	}
	while (bfs ()){
	    int f;
        do{
            for (int i = 0; i < n; i ++) start [i] = 0;
            f = dfs (s, 1000000000);
        } while (f);
	}
	for (int u = 0; u <= L + M; u ++){
        if (level [u] == -1) continue;
        for (edge e : adj [u]){
            if (u < L && e.to != t) continue;
            if (level [e.to] == -1){
                if (u != s) Alm [u] = 1;
                if (e.to != t) Alm [e.to] = 1;
            }
        }
	}
	queue <pair <int, int> > q;
	for (int u = 0; u < L + M; u ++){
	    if (adj [u].size () == 1) Blm [u] = 1;
	    bre [u] = adj [u].size () - 1;
	    if (bre [u] == 1 && Alm [u]){
            used [u] = 1;
            q.push ({u, 1});
	    }
	}
	while (!q.empty ()){
        auto p = q.front ();
        int u = p.first, x = p.second;
        q.pop ();
        if (x == 1){
            for (edge e : adj [u]){
                if (e.idx != -1 && !Bs [e.idx]){
                    As [e.idx] = 1;
                    if (!used [e.to]) q.push ({e.to, 0});
                    used [e.to] = 1;
                    break;
                }
            }
        }
        if (x == 0){
            for (edge e : adj [u]){
                if (e.idx != -1 && !As [e.idx]){
                    Bs [e.idx] = 1;
                    bre [e.to] --;
                    if (bre [e.to] == 1 && !used [e.to]){
                        used [e.to] = 1;
                        q.push ({e.to, 1});
                    }
                }
            }
        }
	}
	int al = 0, am = 0, as = 0, bl = 0, bm = 0, bs = 0;
	for (int i = 0; i < L; i ++){
        if (Alm [i]) al ++;
        if (Blm [i]) bl ++;
	}
	for (int i = L; i < L + M; i ++){
        if (Alm [i]) am ++;
        if (Blm [i]) bm ++;
	}
	for (int i = 0; i < N; i ++){
        if (As [i]) as ++;
        if (Bs [i]) bs ++;
	}
	cout << maxflow << ' ' << as << ' ' << bs << ' ' << al << ' ' << bl << ' ' << am << ' ' << bm << '\n';
	for (int i = 0; i < N; i ++){
        if (As [i]) cout << i + 1 <<  ' ';
	}
	cout << '\n';
	for (int i = 0; i < N; i ++){
        if (Bs [i]) cout << i + 1 <<  ' ';
	}
	cout << '\n';
	for (int i = 0; i < L; i ++){
        if (Alm [i]) cout << i + 1 <<  ' ';
	}
	cout << '\n';
	for (int i = 0; i < L; i ++){
        if (Blm [i]) cout << i + 1 <<  ' ';
	}
	cout << '\n';
	for (int i = 0; i < M; i ++){
        if (Alm [L + i]) cout << i + 1 <<  ' ';
	}
	cout << '\n';
	for (int i = 0; i < M; i ++){
        if (Blm [L + i]) cout << i + 1 <<  ' ';
	}
	cout << '\n';

}
/*
6 3 3
1 1
2 1
2 2
3 1
3 2
3 3
*/
