#include <iostream>
#include <bitset>
#include <set>
#include <vector>
using namespace std;

int L[1000], M[1000];
std::set<int> teams[1000];

int tcnt[1000], lcnt[1000], mcnt[1000];

int main() {
	int N, Lc, Mc;
	cin >> N >> Lc >> Mc;
	for(int i = 0;i < N;i ++) {
		cin >> L[i] >> M[i];
		L[i]--;
		M[i]--;
	}

	int maxCnt = 0;
	for(int perm = 0;perm < (1<<N);perm ++) {
		std::bitset<1000> inTeam(perm);
		std::bitset<1000> Lu(0);
		std::bitset<1000> Mu(0);

		bool fail = false;
		for(int i = 0;i < N;i ++) {
			if(!inTeam[i]) continue;

			if(Lu[L[i]] or Mu[M[i]]) {
				fail = true;
				break;
			}

			Lu[L[i]] = true;
			Mu[M[i]] = true;
		}
		if(fail) continue;

		int cnt = 0;
		for(int i = 0;i < N;i ++) cnt += inTeam[i];
		if(cnt > maxCnt) maxCnt = cnt;
		teams[cnt].insert(perm);
	}

	for(auto team : teams[maxCnt]) {
		std::bitset<1000> inTeam(team);
		for(int i = 0;i < N;i ++) {
			if(!inTeam[i]) continue;
			tcnt[i] ++;
			lcnt[L[i]] ++;
			mcnt[M[i]] ++;
		}

	}

	const int target = teams[maxCnt].size();
	std::vector<int> always_t, never_t, always_l, never_l, always_m, never_m;
	for(int i = 0;i < N;i ++) {
		if(tcnt[i] == target) always_t.push_back(i);
		if(tcnt[i] == 0) never_t.push_back(i);
	}
	for(int i = 0;i < Lc;i ++) {
		if(lcnt[i] == target) always_l.push_back(i);
		if(lcnt[i] == 0) never_l.push_back(i);
	}
	for(int i = 0;i < Mc;i ++) {
		if(mcnt[i] == target) always_m.push_back(i);
		if(mcnt[i] == 0) never_m.push_back(i);
	}
	cout << maxCnt << ' '
	<< always_t.size() << ' ' << never_t.size() << ' ' 
	<< always_l.size() << ' ' << never_l.size() << ' ' 
	<< always_m.size() << ' ' << never_m.size() << ' ' 
	<< endl;

	for(auto x : always_t) cout << x+1 << ' '; cout << '\n';
	for(auto x : never_t) cout << x+1 << ' '; cout << '\n';
	for(auto x : always_l) cout << x+1 << ' '; cout << '\n';
	for(auto x : never_l) cout << x+1 << ' '; cout << '\n';
	for(auto x : always_m) cout << x+1 << ' '; cout << '\n';
	for(auto x : never_m) cout << x+1 << ' '; cout << '\n';
	return 0;
}
