#include <iostream>
#include <unordered_map>
using namespace std;

typedef unsigned long long ull;

// TODO vector of normalized ints
std::string inp;
int from = 0;

ull queryWithLen(int len) {
	ull ans = 0;
	std::unordered_map<ull, ull> map;

	ull hash = 0;
	const ull BASE = 27;
	ull maxMul = 1;
	ull prevMaxMul = 1;
	for(int i = from;i < len+from;i ++) {
		hash *= BASE;
		prevMaxMul = maxMul;
		maxMul *= BASE;
		hash += inp[i];
	}
	maxMul = prevMaxMul;
	ans += map[hash] == 0;
	map[hash] ++;
	//cout << inp.substr(0, len) << ' ' << hash << endl;

	//cout << "HERE " << len << ' ' << maxMul << endl;
	const int S = inp.size();
	for(int i = from+len;i < S;i ++) {
		//cout << "======\n";
		hash -= inp[i-len] * maxMul;
		//cout << inp.substr(i-len, len) << ' ' << hash << endl;
		hash *= BASE;
		hash += inp[i];
		ans += map[hash] == 0;
		map[hash] ++;
		//cout << inp.substr(i-len, len) << ' ' << hash << endl;
	}

	//cout << "END " << len << ' ' << ans << endl;

	return ans;
}

ull query() {
	if(inp.size() == from) return 0;

	ull ans = 0;
	for(int i = 1;i < inp.size()-from;i ++) {
		ans += queryWithLen(i);
	}
	return ans + 1; // +1 for len=N
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> inp;

	int Q; cin >> Q;

	cout << query() << ' ';

	for(int i = 0;i < Q;i ++) {
		int op; cin >> op;

		if(op == 1) {
			char val; cin >> val;
			inp += val;
			cout << query() << ' ';
		} else {
			from ++;
			cout << query() << ' ';
		}
		//cout << inp << endl;
	}
	return 0;
}
