#pragma GCC optimize "Ofast"
#include <iostream>
#include <unordered_map>
#include <bitset>
#include <cstring> // memset
using namespace std;

typedef unsigned long long ull;

// TODO vector of normalized ints
std::string inp;
int from = 0;

const ull BASE = 27;
const int MAX_NPQ = 2e5+5;
std::unordered_map<ull, ull> map[MAX_NPQ];

ull _hash(int pos, int len) {
	ull hash = 0;
	for(int i = pos+from;i < pos+from+len;i ++) {
		hash *= BASE;
		hash += inp[i];
		//hash %= MODMASK;
	}
	return hash;
}

ull ans = 0;

void queryWithLen(int len) {
	ull hash = _hash(0, len);
	ull maxMul = 1;
	for(int i = 0;i < len-1;i ++) maxMul *= BASE;

	ans += map[len][hash] == 0;
	map[len][hash] ++;
	
	//ans += !map[hash & MODMASK];
	//map[hash & MODMASK] = true;

	//cout << inp.substr(0, len) << ' ' << hash << endl;

	//cout << "HERE " << len << ' ' << maxMul << endl;
	const int S = inp.size();
	for(int i = from+len;i < S;i ++) {
		hash -= inp[i-len] * maxMul;
		hash *= BASE;
		hash += inp[i];

		//hash %= MODMASK;
		ans += map[len][hash] == 0;
		map[len][hash] ++;

		//ans += !map[hash & MODMASK];
		//map[hash & MODMASK] = true;

		//cout << inp.substr(i-len, len) << ' ' << hash << endl;
	}

	//cout << "END " << len << ' ' << ans << endl;
}

void query() {
	ans = 0;
	for(int i = 1;i < inp.size()-from+1;i ++) queryWithLen(i);
	//if(inp.size()-from != 0) ans ++; // +1 for len=N
}

void modOp1() {
	for(int i = 1;i < inp.size()-from+1;i ++) {
		ull hash = _hash(inp.size()-from-i, i);
		//cout << "adding " << inp.substr(inp.size()-from-i+1, i) << ' ' << hash << endl;
		//cout << map[i][hash] << endl;
		if(map[i][hash] == 0) ans ++;
		map[i][hash] ++;
	}
}

void modOp2() {
	for(int i = 1;i < inp.size()-from+2;i ++) {
		ull hash = _hash(-1, i);
		//cout << "removing " << inp.substr(from-1, i) << ' ' << hash << endl;
		map[i][hash] --;
		//cout << map[i][hash] << endl;
		if(map[i][hash] == 0) ans --;
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> inp;

	query();
	cout << ans << ' ';

	int Q; cin >> Q;
	for(int i = 0;i < Q;i ++) {
		int op; cin >> op;

		if(op == 1) {
			char val; cin >> val;
			inp += val;
			modOp1();
			cout << ans << ' ';
			//break;
		} else {
			from ++;
			modOp2();
			cout << ans << ' ';
			if(from > 100) {
				inp = inp.substr(from, inp.size()-from);
				from = 0;
			}
			//break;
		}
		//cout << inp << endl;
	}
	return 0;
}
