#include<bits/stdc++.h>

#pragma GCC compile("O3")

#define pb push_back
#define fr first
#define sc second
#define bit(x) x&(-x)
#define de(x) cout << #x << " = " << x << endl;
#define all(container) container.begin(), container.end()
#define endl '\n'

using namespace std;

struct circle{
    double x, y, r;
    circle() {}
    circle(double _x, double _y, double _r) {x = _x; y = _y; r = _r;}
};

const int MAXN = 128;
const double SHIFT = 0.000000001;

double gx, gy;
int n;
circle A[MAXN];

double dist(circle a, circle b){
    return sqrt(abs(a.x - b.x) * abs(a.x - b.x) + abs(a.y - b.y) * abs(a.y - b.y));
}

bool ok(circle C){
    for(int i = 0; i < n; i ++){
        if(dist(C, A[i]) < (C.r + A[i].r)){
            return false;
        }
    }
    return true;
}

double bin_search(double x, double y){
    double l = 1, r = 1000, ans;
    while(l <= r){
        double m = (l + r) / 2;
        if(ok(circle(x, y, m))){
            l = m + SHIFT;
            ans = m;
        }
        else{
            r = m - SHIFT;
        }
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL);
    cout << setprecision(9) << fixed;
    cin >> n;
    for(int i = 0; i < n; i ++){
        cin >> A[i].x >> A[i].y >> A[i].r;
    }
    double ans = 0;
    ans = max(ans, bin_search(   0,    0));
    ans = max(ans, bin_search(   0, 1000));
    ans = max(ans, bin_search(1000,    0));
    ans = max(ans, bin_search(1000, 1000));
    cout << ans << endl;
}
/**
7
42.1337 13.666 191.17
543.21 765.432 55.555
987.987 666.666 321.321
0 1000 100
666.666 66.66 16.6
133.331 666.666666666 123.321
888.8 88.8 8.8
*/
