#include <bits/stdc++.h>
using namespace std;
//T+N
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ll mod = 1e9 + 7;
template<class T, class T2> inline bool chkmax(T &a, const T2 &b) {return a < b ? a = b, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &a, const T2 &b) {return a > b ? a = b, 1 : 0;}
template<class T> inline void fix(T &a) {if(a >= mod | a <= -mod) {a %= mod;} if(a < 0) {a += mod;}}

struct Point {
    ld x, y;
    bool operator <(const Point &other) const {
        return x < other.x;
    }
};

const ld eps = 1e-9;

pair<bool, Point> inter(Point a, Point b, Point c, Point d) {
    ld slope1;
    if(abs(a.x - b.x) <= eps) {
        slope1 = 1e18;
    } else {
        slope1 = (a.y - b.y) / (a.x - b.x);
    }
    ld add1 = (a.y - slope1 * a.x);
    ld slope2;
    if(abs(c.x - d.x) <= eps) {
        slope2 = 1e18;
    } else {
        slope2 = (c.y - d.y) / (c.x - d.x);
    }
    ld add2 = (c.y - slope2 * c.x);
    if(abs(slope1 - slope2) <= eps) {
        return {false, {0, 0}};
    }
    ld x = (add2 - add1) / (slope1 - slope2);
    return {true, {x, x * slope1 + add1}};
}

pair<bool, ld> getSlope(Point a, Point b) {
    if(abs(a.x - b.x) <= eps) {return {false, 0};}
    return {true, (a.y - b.y) / (a.x - b.x)};
}

Point pointOfPerp(ld slope, Point a) {
    ld newSlope = -(1.f / slope);
    ld newAdd = a.y - newSlope * a.x;
    return {newSlope, newAdd};
}

ld dist(Point a, Point b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

struct FakePoint {
    ld x, y, rad;
    bool operator <(const Point &other) const {
        return x < other.x;
    }
    operator Point() const {
        return {x, y};
    }
};

Point getRad(FakePoint a, FakePoint b) {
    ld slope, add;
    auto now = getSlope(a, b);
    //cout << "Start " << endl;
    //cout << a.x << " " << a.y << endl;
    //cout << b.x << " " << b.y << endl;
    //cout << now.first << " " << now.second << endl;
    if(now.first) {
        slope = now.second;
        add = a.y - slope * a.x;
        //cout << add << endl;
        ld l = a.x, r = b.x;
        for(int iter = 0; iter < 50; iter ++) {
            //cout << l << " " << r << endl;
            ld m = (l + r) / 2.f;
            if(dist({m, m * slope + add}, a) - a.rad < dist({m, m * slope + add}, b) - b.rad) {
                l = m;
            } else {
                r = m;
            }
        }
        //cout << l  << " " << l * slope + add << "!!! " << slope << " " << add << " " << dist({l, l * slope + add}, a) - a.rad << " " << dist({l, l * slope + add}, b) - b.rad << endl;
        return pointOfPerp(slope, {l, l * slope + add});
    } else {
        slope = 0;
        if(a.y < b.y) {
            return {1e20, (a.y + b.y + a.rad - b.rad) / 2.f};
        } else {
            return {1e20, (a.y + b.y + a.rad - b.rad) / 2.f};
        }
    }
}

const int MAX_N = 110;
FakePoint p[MAX_N];
int n;

ld f(Point now) {
    if(now.x < 0 || now.y < 0 || now.x > 1000 || now.y > 1000) {
        return 0;
    }
    ld best = mod;
    for(int i = 0; i < n; i ++) {
        chkmin(best, dist(now, p[i]) - p[i].rad);
    }
    return best;
}

signed main() {
    //ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> p[i].x >> p[i].y >> p[i].rad;
    }
    sort(p, p + n);
    ld ret = 0;
    //chkmax(ret, f({434.939950686,341.298204535}));
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            auto now = getRad(p[i], p[j]);
            auto radCentre = inter({0, now.y}, {1, now.x + now.y}, {1000, 0}, {1000, 1000});
            chkmax(ret, f(radCentre.second));
            radCentre = inter({0, now.y}, {1, now.x + now.y}, {0, 0}, {0, 1000});
            chkmax(ret, f(radCentre.second));
            radCentre = inter({0, now.y}, {1, now.x + now.y}, {0, 0}, {1000, 0});
            chkmax(ret, f(radCentre.second));
            radCentre = inter({0, now.y}, {1, now.x + now.y}, {0, 1000}, {1000, 1000});
            chkmax(ret, f(radCentre.second));

        }
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            for(int k = j + 1; k < n; k ++) {
                auto now1 = getRad(p[i], p[j]), now2 = getRad(p[j], p[k]);
                //cout << now1.x << " " << now1.y << endl;
                //cout << now1.x * 434.939950686 + now1.y << endl;
                //cout << now2.x << " " << now2.y << endl;
                auto radCentre = inter({0, now1.y}, {10, 10 * now1.x + now1.y}, {0, now2.y}, {10, 10 * now2.x + now2.y});
                //radCentre = {0, {434.939950686, 341.298204535}};
                assert((dist(radCentre.second, p[i]) - p[i].rad - dist(radCentre.second, p[j]) + p[j].rad) <= eps);
                assert((dist(radCentre.second, p[j]) - p[j].rad - dist(radCentre.second, p[k]) + p[k].rad) <= eps);
                cout << (dist(radCentre.second, p[j]) - p[j].rad - dist(radCentre.second, p[k]) + p[k].rad) << endl;
                if(radCentre.first == false) {continue;}
                //cout << p[i].x << " " << p[i].y << endl;
                //cout << p[j].x << " " << p[j].y << endl;
                //cout << p[k].x << " " << p[k].y << endl;
                //cout << radCentre.second.x << " " << radCentre.second.y << endl;
                chkmax(ret, f(radCentre.second));
            }
        }
    }
    cout << ret << endl;
    return 0;
}


/*
3
42.1337 13.666 191.17
987.987 666.666 321.321
133.331 666.666666666 123.321
*/
