#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

struct circle
{
    double x, y, r;
};

const int maxn = 103;
const double eps = 0.000001;
const double pi = acos(-1);

int n;
circle circles[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    cin >> circles[i].x >> circles[i].y >> circles[i].r;
}

bool check(long double x, long double y, long double r)
{
    for (int k = 1; k <= n; k++)
    {
        long double r1 = (x - circles[k].x) * (x - circles[k].x) + (y - circles[k].y) * (y - circles[k].y) - (r + circles[k].r) * (r + circles[k].r);
        if (r1 < -eps)
        return false;
    }

    return true;
}

bool can(long double r)
{
    for (int i = 1; i <= n; i++)
    for (long double angle = 0; angle < 360.0; angle += 0.002)
    {
        long double big_r = circles[i].r + r;
        long double x = cos(angle * pi / 180.0) * big_r + circles[i].x, y = sin(angle * pi / 180.0) * big_r + circles[i].y;
        if (x >= r && x + r <= 1000.0 && y >= r && y + r <= 1000.0)
            if (check(x, y, r))
            return true;
    }

    return false;
}

void solve()
{
    long double low = 0, high = 500;
    while (high - low > eps)
    {
        long double mid = (low + high) / 2.0;
        if (can(mid))
        low = mid;

        else
        high = mid;
    }

    cout << fixed;
    cout << setprecision(12) << low << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
7
42.1337 13.666 191.17
543.21 765.432 55.555
987.987 666.666 321.321
0 1000 100
666.666 66.66 16.6
133.331 666.666666666 123.321
888.8 88.8 8.8
*/
