#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 4003;

int n, s, t;
vector <pair <int, int> > adj[maxn];
int a[maxn], b[maxn];
void read()
{
    cin >> n >> s >> t;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i] >> b[i];
        adj[a[i]].push_back({b[i], i});
    }
}

bool banned_idx[maxn], banned_lang[maxn], banned_mus[maxn];
int match[maxn];
bool used[maxn];

bool dfs(int ver)
{
    if (banned_lang[ver])
    return false;

    for (auto i: adj[ver])
    if (!used[i.first] && !banned_mus[i.first] && !banned_idx[i.second])
    {
        used[i.first] = true;
        if (match[i.first] == -1 || dfs(match[i.first]))
        {
            match[i.first] = ver;
            return true;
        }
    }

    return false;
}

int max_matching()
{
    memset(match, -1, sizeof(match));
    for (int i = 1; i <= s; i++)
    {
        for (int j = 1; j <= t; j++)
            used[j] = false;

        dfs(i);
    }

    int ans = 0;
    for (int i = 1; i <= t; i++)
        if (match[i] != -1)
        ans++;

    return ans;
}

bool can_always_idx[maxn];
bool can_lang[maxn], can_mus[maxn];
void solve()
{
    int k = max_matching();
    vector <int> always_idx, always_lang, always_mus;
    for (int i = 1; i <= n; i++)
    {
        banned_idx[i] = true;
        if (max_matching() != k)
        {
            can_always_idx[i] = true;
            can_lang[a[i]] = true;
            can_mus[b[i]] = true;
            always_idx.push_back(i);
        }

        banned_idx[i] = false;
    }

    for (int i = 1; i <= s; i++)
    {
        banned_lang[i] = true;
        if (max_matching() != k)
            always_lang.push_back(i);

        banned_lang[i] = false;
    }

    for (int i = 1; i <= t; i++)
    {
        banned_mus[i] = true;
        if (max_matching() != k)
            always_mus.push_back(i);

        banned_mus[i] = false;
    }

    vector <int> never_idx, never_lang, never_mus;
    for (int i = 1; i <= n; i++)
    if (!can_always_idx[i])
    {
        banned_idx[i] = true;
        banned_lang[a[i]] = true;
        banned_mus[b[i]] = true;

        if (max_matching() + 1 != k)
            never_idx.push_back(i);

        else
        {
            can_lang[a[i]] = true;
            can_mus[b[i]] = true;
        }

        banned_idx[i] = false;
        banned_lang[a[i]] = false;
        banned_mus[b[i]] = false;
    }

    for (int i = 1; i <= s; i++)
        if (!can_lang[i])
        never_lang.push_back(i);

    for (int i = 1; i <= t; i++)
        if (!can_mus[i])
        never_mus.push_back(i);

    cout << k << " " << always_idx.size() << " " << never_idx.size() << " " << always_lang.size() << " " << never_lang.size() << " " << always_mus.size() << " " << never_mus.size() << endl;

    for (auto i: always_idx)
        cout << i << " ";
    cout << endl;

    for (auto i: never_idx)
        cout << i << " ";
    cout << endl;

    for (auto i: always_lang)
        cout << i << " ";
    cout << endl;

    for (auto i: never_lang)
        cout << i << " ";
    cout << endl;

    for (auto i: always_mus)
        cout << i << " ";

    cout << endl;
    for (auto i: never_mus)
        cout << i << " ";
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
/*
6 4 5
1 1
2 1
3 2
3 3
3 4
4 4
*/
