#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

const int maxn = 2e5 + 3;
const int maxlog = 19;

string s;
int q, sz, l;
void read()
{
    cin >> s >> q;
}

struct suffix
{
    int num1, num2, idx;
    bool operator < (const suffix &t) const
    {
        if (num1 != t.num1)
            return num1 < t.num1;

        return num2 < t.num2;
    }
};

int idx[maxn][maxlog];
suffix suffixes[maxn];
int suffix_array[maxn];

int lcp(int i, int j)
{
    int ans = 0;
    for (int k = maxlog-1; k >= 0; k--)
        if (i + (1 << k) - 1 <= sz && j + (1 << k) - 1 <= sz && idx[i][k] == idx[j][k])
        ans += (1 << k), i += (1 << k), j += (1 << k);

    return ans;
}

long long get_suffix_array()
{
    for (int i = l; i <= sz; i++)
    idx[i][0] = s[i-1] - '0';

    for (int j = 1; j < maxlog; j++)
    {
        for (int i = l; i <= sz; i++)
        {
            suffixes[i].idx = i;
            suffixes[i].num1 = idx[i][j-1];
            if (i + (1 << (j-1)) > sz)
                suffixes[i].num2 = -1;

            else
                suffixes[i].num2 = idx[i + (1 << (j-1))][j-1];
        }

        sort (suffixes + l, suffixes + sz + 1);
        int curr_idx = 1;
        idx[suffixes[l].idx][j] = curr_idx;
        for (int i = l+1; i <= sz; i++)
        {
            if (suffixes[i].num1 != suffixes[i-1].num1 || suffixes[i].num2 != suffixes[i-1].num2)
            curr_idx++;

            idx[suffixes[i].idx][j] = curr_idx;
        }
    }

    for (int i = l; i <= sz; i++)
        suffix_array[idx[i][maxlog-1]] = i;

    long long ans = 1ll * (sz - l + 1) * (sz - l + 2) / 2;
    for (int i = 1; i <= sz - l; i++)
    {
        //cout << suffix_array[i] << " " << suffix_array[i+1] << " " << lcp(suffix_array[i], suffix_array[i+1]) << endl;
        ans -= lcp(suffix_array[i], suffix_array[i+1]);
    }
    return ans;
}

void solve()
{
    l = 1;
    sz = (int)s.size();

    cout << get_suffix_array() << " ";
    while (q--)
    {
        int type;
        cin >> type;

        if (type == 2)
        l++;

        else
        {
            char let;
            cin >> let;

            s += let;
            sz++;
        }

        cout << get_suffix_array() << " ";
    }

    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
