#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

const int maxn = 100003;
const int maxlog = 20;

string s;
int q, sz, l;
void read()
{
    cin >> s >> q;
}

struct suffix
{
    int num1, num2, idx;
    bool operator < (const suffix &t) const
    {
        if (num1 != t.num1)
            return num1 < t.num1;

        return num2 < t.num2;
    }
};

int idx[maxn][maxlog];
suffix suffixes[maxn], suffixes1[maxn];
int suffix_array[maxn];

int lcp(int i, int j)
{
    int ans = 0;
    for (int k = maxlog-1; k >= 0; k--)
        if (i + (1 << k) - 1 <= sz && j + (1 << k) - 1 <= sz && idx[i][k] == idx[j][k])
        ans += (1 << k), i += (1 << k), j += (1 << k);

    return ans;
}

vector <int> v1[maxn], v2[maxn];
void sort_it()
{
    for (int i = 0; i <= sz; i++)
    v1[i].clear(), v2[i].clear();

    for (int i = l; i <= sz; i++)
        v2[suffixes[i].num2].push_back(i);

    for (int i = 0; i <= sz; i++)
        for (auto j: v2[i])
        v1[suffixes[j].num1].push_back(j);

    int idx = l;
    for (int i = 0; i <= sz; i++)
        for (auto j: v1[i])
        suffixes1[idx++] = suffixes[j];

    for (int i = l; i <= sz; i++)
        suffixes[i] = suffixes1[i];
}

long long get_suffix_array()
{
    for (int i = l; i <= sz; i++)
    idx[i][0] = s[i-1] - 'a' + 1;

    for (int j = 1; j < maxlog; j++)
    {
        for (int i = l; i <= sz; i++)
        {
            suffixes[i].idx = i;
            suffixes[i].num1 = idx[i][j-1];
            if (i + (1 << (j-1)) > sz)
                suffixes[i].num2 = 0;

            else
                suffixes[i].num2 = idx[i + (1 << (j-1))][j-1];
        }

        sort_it();
        int curr_idx = 1;
        idx[suffixes[l].idx][j] = curr_idx;
        for (int i = l+1; i <= sz; i++)
        {
            if (suffixes[i].num1 != suffixes[i-1].num1 || suffixes[i].num2 != suffixes[i-1].num2)
            curr_idx++;

            idx[suffixes[i].idx][j] = curr_idx;
        }
    }

    for (int i = l; i <= sz; i++)
        suffix_array[idx[i][maxlog-1]] = i;

    long long ans = 1ll * (sz - l + 1) * (sz - l + 2) / 2;
    for (int i = 1; i <= sz - l; i++)
        ans -= lcp(suffix_array[i], suffix_array[i+1]);

    return ans;
}

struct query
{
    int type;
    char let;
};

query queries[maxn];
int nxt[maxn], prv[maxn], pos[maxn];
bool is = false;
void solve()
{
    l = 1;
    sz = (int)s.size();

    cout << get_suffix_array() << " ";
    for (int test = 1; test <= q; test++)
    {
        int type;
        cin >> type;

        if (type == 2)
            queries[test].type = 2;

        else
        {
            char let;
            cin >> let;

            queries[test].type = 1;
            queries[test].let = let;
            is = true;
        }
    }

    if (is)
    {
        for (int i = 1; i <= q; i++)
        {
            if (queries[i].type == 2)
                l++;

            else
            {
                s += queries[i].let++;
                sz++;
            }

            cout << get_suffix_array() << " ";
        }

        cout << endl;
    }

    else
    {
        long long sum = 0;
        for (int i = 1; i <= sz - l; i++)
        sum += lcp(suffix_array[i], suffix_array[i+1]);
        for (int i = 1; i <= sz; i++)
        {
            prv[i] = i-1;
            nxt[i] = i + 1;
            pos[suffix_array[i]] = i;
        }

        for (int i = 1; i <= q; i++)
        {
            int curr = pos[l];
            if (prv[curr] != 0)
                sum -= lcp(suffix_array[curr], suffix_array[prv[curr]]);

            if (nxt[curr] != sz + 1)
                sum -= lcp(suffix_array[curr], suffix_array[nxt[curr]]);

            if (prv[curr] != 0 && nxt[curr] != sz + 1)
                sum += lcp(suffix_array[prv[curr]], suffix_array[nxt[curr]]);

            nxt[prv[curr]] = nxt[curr];
            prv[nxt[curr]] = prv[curr];
            l++;

            cout << 1ll * (sz - l + 1) * (sz - l + 2) / 2 - sum << " ";
        }

        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
