#include<iostream>
#include<vector>
#include<cmath>
#include<iomanip>
#define eps 1e-9
using namespace std;
struct incen{
    double x,y,r;
};
vector<incen>incens;
pair<double,double>corners[4]={{0,0},{0,1000},{1000,1000},{1000,0}};
int n;
double msqrt(double a){
    double l=0,r=a;
    double m=(l+r)/2.0;
    while(m*m-eps>a || m*m+eps<a){
        //cout<<m<<endl;
        if(m*m>a){
            r=m;
        }else{
            l=m;
        }
        m=(l+r)/2.0;
    }
    return l;

}
bool intersect(incen a,incen b){
    double c=a.x-b.x,d=a.y-b.y;
    double dist=msqrt(c*c+d*d);
    //cout<<"check: "<<a.r<<" "<<b.r<<" "<<dist<<endl;
    if(a.r+b.r+1>dist){
        return 0;
    }
    return 1;
}
bool check(incen curr){
    //cout<<curr.r<<endl;
    for(int i=0;i<n;i++){
        if(intersect(curr,incens[i])){
            return 0;
        }
    }
    return 1;
}
int main(){
    //cout<<fixed<<setprecision(9)<<msqrt(10)<<endl;
    cin>>n;
    for(int i=0;i<n;i++){
        double a,b,c;
        cin>>a>>b>>c;
        incens.push_back({a,b,c});
    }
    double ans=0;
    for(int i=0;i<4;i++){
        for(int j=0;j<n;j++){
            double a=corners[i].first-incens[j].x,b=corners[i].second-incens[j].y;
            double cr=msqrt(a*a+b*b)-incens[j].r;
            //cout<<cr<<endl;
            if(cr<0)continue;
            if(check({corners[i].first,corners[i].second,cr})){
                ans=max(ans,cr);
            }
        }
    }
    cout<<fixed<<setprecision(9)<<ans<<endl;
    return 0;
}
