#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, s, t;
vector<pair<int, int>> students;

void read() {
    cin >> n >> s >> t;

    students.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> students[i].first >> students[i].second;
    }
}

vector<vector<int>> adj_list;

int max_length = 0;
vector<vector<int>> paths;
vector<vector<bool>> work_together;
vector<int> path;
vector<bool> seen;

void dfs(int node) {
    path.emplace_back(node);
    seen[node] = true;

    if (path.size() > max_length) {
        max_length = path.size();
        paths.clear();
        paths.emplace_back(path);
    } else if (path.size() == max_length) {
        paths.emplace_back(path);
    }

    for (int adj_node : adj_list[node]) {
        if (!seen[adj_node]) {
            bool ok = true;
            for (int path_node : path) {
                if (!work_together[path_node][adj_node]) {
                    ok = false;
                    break;
                }
            }

            if (ok) {
                dfs(adj_node);
            }
        }
    }

    path.pop_back();
    seen[node] = false;
}

int main() {
    set_io();

    read();

    adj_list.resize(n);
    work_together.resize(n, vector<bool>(n, false));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (students[i].first != students[j].first
                && students[i].second != students[j].second) {
                    adj_list[i].emplace_back(j);
                    adj_list[j].emplace_back(i);
                    work_together[i][j] = work_together[j][i] = true;
                }
        }
    }

    seen.resize(n, false);
    for (int i = 0; i < n; i++) {
        dfs(i);
    }

    cout << paths[0].size() << ' ';

    vector<int> students_count(n, 0);
    vector<int> languages_count(s, 0);
    vector<int> instruments_count(t, 0);
    for (auto &path : paths) {
        for (auto &student : path) {
            students_count[student]++;
            languages_count[students[student].first - 1]++;
            instruments_count[students[student].second - 1]++;
        }
    }

    int a = 0, b = 0;
    for (int i = 0; i < n; i++) {
        if (students_count[i] == 0) {
            b++;
        } else if (students_count[i] == paths.size()) {
            a++;
        }
    }

    cout << a << ' ' << b << ' ';

    a = 0, b = 0;
    for (int i = 0; i < s; i++) {
        if (languages_count[i] == 0) {
            b++;
        } else if (languages_count[i] == paths.size()) {
            a++;
        }
    }

    cout << a << ' ' << b << ' ';

    a = 0, b = 0;
    for (int i = 0; i < t; i++) {
        if (instruments_count[i] == 0) {
            b++;
        } else if (instruments_count[i] == paths.size()) {
            a++;
        }
    }

    cout << a << ' ' << b << endl;

    for (int i = 0; i < n; i++) {
        if (students_count[i] == paths.size()) {
            cout << (i + 1) << ' ';
        }
    }
    cout << endl;
    for (int i = 0; i < n; i++) {
        if (students_count[i] == 0) {
            cout << (i + 1) << ' ';
        }
    }
    cout << endl;

    for (int i = 0; i < s; i++) {
        if (languages_count[i] == paths.size()) {
            cout << (i + 1) << ' ';
        }
    }
    cout << endl;
    for (int i = 0; i < s; i++) {
        if (languages_count[i] == 0) {
            cout << (i + 1) << ' ';
        }
    }
    cout << endl;

    for (int i = 0; i < t; i++) {
        if (instruments_count[i] == paths.size()) {
            cout << (i + 1) << ' ';
        }
    }
    cout << endl;
    for (int i = 0; i < t; i++) {
        if (instruments_count[i] == 0) {
            cout << (i + 1) << ' ';
        }
    }
    cout << endl;

    return EXIT_SUCCESS;
}
