#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, s, t;
vector<pair<int, int>> students;

void read() {
    cin >> n >> s >> t;

    students.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> students[i].first >> students[i].second;
        students[i].first--;
        students[i].second--;
    }
}

vector<int> max_lengths;
set<int> s_always_available;
set<int> s_never_been;

vector<bool> s_seen;

void dfs(int node) {
    s_seen[node] = true;

    int max_value = 0;
    for (int i = 0; i < node; i++) {
        if (students[i].first != students[node].first
            && students[i].second != students[node].second) {
            if (max_lengths[i] > max_value) {
                max_value = max_lengths[i];
            }
        }
    }

    for (int i = 0; i < node; i++) {
        if (students[i].first != students[node].first
            && students[i].second != students[node].second) {
            if (max_lengths[i] == max_value && !s_seen[i]) {
                dfs(i);
            }
        }
    }
}

void compute_students() {
    int max_length = *max_element(max_lengths.begin(), max_lengths.end());
    for (int i = 0; i < n; i++) {
        if (max_lengths[i] == max_length) {
            int student_id = i;
            while (student_id != -1) {
                s_always_available.emplace(student_id);

                int next_student_id = -1;
                int max_value = 0, cnt = 0;
                for (int j = i - 1; j >= 0; j--) {
                    if (students[i].first != students[j].first
                        && students[i].second != students[j].second) {
                        if (max_lengths[j] > max_value) {
                            max_value = max_lengths[j];
                            cnt = 1;
                        } else if (max_lengths[j] == max_value) {
                            cnt++;
                        }
                    }
                }

                if (cnt > 1) {
                    break;
                }

                student_id = next_student_id;
            }
        }
    }

    s_seen.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (max_lengths[i] == max_length) {
            dfs(i);
        }
    }

    for (int i = 0; i < n; i++) {
        if (!s_seen[i]) {
            s_never_been.emplace(i);
        }
    }
}

int main() {
    set_io();

    read();

    max_lengths.resize(n, 1);
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (students[i].first != students[j].first
                && students[i].second != students[j].second) {
                max_lengths[i] = max(max_lengths[i], max_lengths[j] + 1);
            }
        }
    }

    int max_length_index = 0;
    for (int i = 1; i < n; i++) {
        if (max_lengths[i] > max_lengths[max_length_index]) {
            max_length_index = i;
        }
    }

    cout << max_lengths[max_length_index] << ' ';

    compute_students();

    cout << s_always_available.size() << ' ' << s_never_been.size() << endl;
    for (int id : s_always_available) {
        cout << (id + 1) << ' ';
    }
    cout << endl;
    for (int id : s_never_been) {
        cout << (id + 1) << ' ';
    }
    cout << endl;

    return EXIT_SUCCESS;
}
