#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, s, t;
vector<pair<int, int>> students;

void read() {
    cin >> n >> s >> t;

    students.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> students[i].first >> students[i].second;
        students[i].first--;
        students[i].second--;
    }
}

vector<int> max_lengths;
vector<int> num_teams;
set<int> s_always_available;
set<int> s_never_been;

vector<bool> s_seen;

void dfs(int node) {
    s_seen[node] = true;

    int max_value = 0;
    for (int i = 0; i < node; i++) {
        if (students[i].first != students[node].first
            && students[i].second != students[node].second) {
            if (max_lengths[i] > max_value) {
                max_value = max_lengths[i];
            }
        }
    }

    for (int i = 0; i < node; i++) {
        if (students[i].first != students[node].first
            && students[i].second != students[node].second) {
            if (max_lengths[i] == max_value && !s_seen[i]) {
                dfs(i);
            }
        }
    }
}

void compute_students() {
    int max_length = *max_element(max_lengths.begin(), max_lengths.end());
    for (int i = 0; i < n; i++) {
        if (max_lengths[i] == max_length) {
            int student_id = i;
            while (student_id != -1) {
                s_always_available.emplace(student_id);

                int next_student_id = -1;
                int max_value = 0, cnt = 0;
                for (int j = i - 1; j >= 0; j--) {
                    if (students[i].first != students[j].first
                        && students[i].second != students[j].second) {
                        if (max_lengths[j] > max_value) {
                            max_value = max_lengths[j];
                            cnt = 1;
                        } else if (max_lengths[j] == max_value) {
                            cnt++;
                        }
                    }
                }

                if (cnt > 1) {
                    break;
                }

                student_id = next_student_id;
            }
        }
    }

    s_seen.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (max_lengths[i] == max_length) {
            dfs(i);
        }
    }

    for (int i = 0; i < n; i++) {
        if (!s_seen[i]) {
            s_never_been.emplace(i);
        }
    }
}

vector<vector<int>> cnt_instruments;
set<int> i_always_available;
set<int> i_never_been;

int cnt_all_teams = 0;

void compute_instruments() {
    cnt_instruments.resize(s, vector<int>(n, 0));
    for (int i = 0; i < s; i++) {
        cnt_instruments[i][0] = students[0].first == i ? 1 : 0;
        for (int j = 1; j < n; j++) {
            int max_value = 0;
            for (int k = 0; k < j; k++) {
                if (students[j].first != students[k].first
                    && students[j].second != students[k].second) {
                    max_value = max(max_value, max_lengths[k]);
                }
            }

            if (students[j].first == i) {
                for (int k = 0; k < j; k++) {
                    if (students[j].first != students[k].first
                        && students[j].second != students[k].second) {
                        if (max_lengths[k] == max_value) {
                            cnt_instruments[i][j] += num_teams[k];
                        }
                    }
                }

                if (cnt_instruments[i][j] == 0) {
                    cnt_instruments[i][j] = 1;
                }
            } else {
                for (int k = 0; k < j; k++) {
                    if (students[j].first != students[k].first
                        && students[j].second != students[k].second) {
                        if (max_lengths[k] == max_value) {
                            cnt_instruments[i][j] += cnt_instruments[i][k];
                        }
                    }
                }
            }
        }
    }

    int max_value = *max_element(max_lengths.begin(), max_lengths.end());

    for (int i = 0; i < s; i++) {
        int cnt_teams = 0;
        for (int j = 0; j < n; j++) {
            if (max_lengths[j] == max_value) {
                cnt_teams += cnt_instruments[i][j];
            }
        }

        if (cnt_teams == 0) {
            i_never_been.emplace(i);
        } else if (cnt_teams == cnt_all_teams) {
            i_always_available.emplace(i);
        }
    }
}

vector<vector<int>> cnt_langs;
set<int> l_always_available;
set<int> l_never_been;

void compute_langs() {
    cnt_langs.resize(t, vector<int>(n, 0));
    for (int i = 0; i < t; i++) {
        cnt_langs[i][0] = students[0].second == i ? 1 : 0;
        for (int j = 1; j < n; j++) {
            int max_value = 0;
            for (int k = 0; k < j; k++) {
                if (students[j].first != students[k].first
                    && students[j].second != students[k].second) {
                    max_value = max(max_value, max_lengths[k]);
                }
            }

            if (students[j].second == i) {
                for (int k = 0; k < j; k++) {
                    if (students[j].first != students[k].first
                        && students[j].second != students[k].second) {
                        if (max_lengths[k] == max_value) {
                            cnt_langs[i][j] += num_teams[k];
                        }
                    }
                }

                if (cnt_langs[i][j] == 0) {
                    cnt_langs[i][j] = 1;
                }
            } else {
                for (int k = 0; k < j; k++) {
                    if (students[j].first != students[k].first
                        && students[j].second != students[k].second) {
                        if (max_lengths[k] == max_value) {
                            cnt_langs[i][j] += cnt_langs[i][k];
                        }
                    }
                }
            }
        }
    }

    int max_value = *max_element(max_lengths.begin(), max_lengths.end());

    for (int i = 0; i < t; i++) {
        int cnt_teams = 0;
        for (int j = 0; j < n; j++) {
            if (max_lengths[j] == max_value) {
                cnt_teams += cnt_langs[i][j];
            }
        }

        if (cnt_teams == 0) {
            l_never_been.emplace(i);
        } else if (cnt_teams == cnt_all_teams) {
            l_always_available.emplace(i);
        }
    }
}

int main() {
    set_io();

    read();

    max_lengths.resize(n, 1);
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (students[i].first != students[j].first
                && students[i].second != students[j].second) {
                max_lengths[i] = max(max_lengths[i], max_lengths[j] + 1);
            }
        }
    }

    num_teams.resize(n, 0);
    num_teams[0] = 1;
    for (int i = 1; i < n; i++) {
        int max_value = 0;
        for (int j = 0; j < i; j++) {
            if (students[i].first != students[j].first
                && students[i].second != students[j].second) {
                max_value = max(max_value, max_lengths[j]);
            }
        }

        for (int j = 0; j < i; j++) {
            if (students[i].first != students[j].first
                && students[i].second != students[j].second) {
                if (max_lengths[j] == max_value) {
                    num_teams[i] += num_teams[j];
                }
            }
        }

        if (num_teams[i] == 0) {
            num_teams[i] = 1;
        }
    }

    int max_length_index = 0;
    for (int i = 1; i < n; i++) {
        if (max_lengths[i] > max_lengths[max_length_index]) {
            max_length_index = i;
        }
    }

    for (int i = 0; i < n; i++) {
        if (max_lengths[i] == max_lengths[max_length_index]) {
            cnt_all_teams += num_teams[i];
        }
    }

    cout << max_lengths[max_length_index] << ' ';

    compute_students();
    compute_instruments();
    compute_langs();

    cout << s_always_available.size() << ' ' << s_never_been.size() << ' ';
    cout << i_always_available.size() << ' ' << i_never_been.size() << ' ';
    cout << l_always_available.size() << ' ' << l_never_been.size() << endl;
    for (int id : s_always_available) {
        cout << (id + 1) << ' ';
    }
    cout << endl;
    for (int id : s_never_been) {
        cout << (id + 1) << ' ';
    }
    cout << endl;
    for (int id : i_always_available) {
        cout << (id + 1) << ' ';
    }
    cout << endl;
    for (int id : i_never_been) {
        cout << (id + 1) << ' ';
    }
    cout << endl;
    for (int id : l_always_available) {
        cout << (id + 1) << ' ';
    }
    cout << endl;
    for (int id : l_never_been) {
        cout << (id + 1) << ' ';
    }
    cout << endl;

    return EXIT_SUCCESS;
}
