#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int ALPHABET_SIZE = 26;

class State {
public:
    int length;
    int to[ALPHABET_SIZE];
    int link;

    State() {
        memset(this->to, -1, sizeof(this->to));
    }
};

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

string s;

int last, curr;
vector<State> sa;

void init() {
    last = curr = 0;
    sa.emplace_back();
    sa[0].length = 0;
    sa[0].link = -1;
}

void add_letter(char letter) {
    sa.emplace_back();
    int curr = sa.size() - 1;
    sa[curr].length = sa[last].length + 1;

    int p = last;
    int letter_index = letter - 'a';
    while (p != -1 && sa[p].to[letter_index] == -1) {
        sa[p].to[letter_index] = curr;
        p = sa[p].link;
    }

    if (p == -1) {
        sa[curr].link = 0;
    } else {
        int q = sa[p].to[letter_index];
        if (sa[q].length == sa[p].length + 1) {
            sa[curr].link = q;
        } else {
            sa.emplace_back(sa[q]);
            sa.back().length = sa[p].length + 1;
            while (p != -1 && sa[p].to[letter_index] == q) {
                sa[p].to[letter_index] = sa.size() - 1;
            }
            sa[q].link = sa[curr].link = sa.size() - 1;
        }
    }

    last = curr;
}

vector<int> dp;

void dfs(int node) {
    dp[node] = 1;
    for (int i = 0; i < ALPHABET_SIZE; i++) {
        if (sa[node].to[i] != -1) {
            dfs(sa[node].to[i]);
            dp[node] += dp[sa[node].to[i]];
        }
    }
}

int main() {
    set_io();

    cin >> s;

    init();

    for (char letter : s) {
        add_letter(letter);
    }

    dp.resize(sa.size(), 0);
    dfs(0);

    cout << (dp[0] - 1) << endl;

    return EXIT_SUCCESS;
}
