#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

class State {
public:
    int length;
    map<char, int> to;
    int link;
};

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

string s;

int last, curr;
vector<State> sa;

void init() {
    last = curr = 0;
    sa.emplace_back();
    sa[0].length = 0;
    sa[0].link = -1;
}

void add_letter(char letter) {
    sa.emplace_back();
    int curr = sa.size() - 1;
    sa[curr].length = sa[last].length + 1;

    int p = last;
    while (p != -1 && !sa[p].to.count(letter)) {
        sa[p].to[letter] = curr;
        p = sa[p].link;
    }

    if (p == -1) {
        sa[curr].link = 0;
    } else {
        int q = sa[p].to[letter];
        if (sa[q].length == sa[p].length + 1) {
            sa[curr].link = q;
        } else {
            sa.emplace_back(sa[q]);
            sa.back().length = sa[p].length + 1;
            while (p != -1 && sa[p].to[letter] == q) {
                sa[p].to[letter] = sa.size() - 1;
            }
            sa[q].link = sa[curr].link = sa.size() - 1;
        }
    }

    last = curr;
}

vector<long long> dp;

void dfs(int node) {
    dp[node] = 1;
    for (auto &i : sa[node].to) {
        dfs(i.second);
        dp[node] += dp[i.second];
    }
}

int main() {
    set_io();

    cin >> s;

    init();

    for (char letter : s) {
        add_letter(letter);
    }

    dp.resize(sa.size(), 0);
    dfs(0);

    cout << (dp[0] - 1) << endl;

    return EXIT_SUCCESS;
}
