#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

class State {
public:
    int length;
    map<char, int> to;
    int link;
};

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

string s;

int last, curr;
vector<State> sa;

void init() {
    sa.clear();
    last = curr = 0;
    sa.emplace_back();
    sa[0].length = 0;
    sa[0].link = -1;
}

void add_letter(char letter) {
    curr = sa.size();
    sa.emplace_back();
    sa[curr].length = sa[last].length + 1;

    int p = last;
    while (p != -1 && !sa[p].to.count(letter)) {
        sa[p].to[letter] = curr;
        p = sa[p].link;
    }

    if (p == -1) {
        sa[curr].link = 0;
    } else {
        int q = sa[p].to[letter];
        if (sa[q].length == sa[p].length + 1) {
            sa[curr].link = q;
        } else {
            sa.emplace_back(sa[q]);
            sa.back().length = sa[p].length + 1;
            while (p != -1 && sa[p].to[letter] == q) {
                sa[p].to[letter] = sa.size() - 1;
                p = sa[p].link;
            }
            sa[q].link = sa[curr].link = sa.size() - 1;
        }
    }

    last = curr;
}

vector<long long> dp;

void dfs(int node) {
    if (dp[node] > 0) {
        return;
    }

    dp[node] = 1;
    for (auto &i : sa[node].to) {
        dfs(i.second);
        dp[node] += dp[i.second];
    }
}

vector<int> prefix;

void construct_prefix(int from) {
    int n = s.size();
    prefix.resize(n - from);
    prefix[0] = 0;
    for (int i = 1; i < n - from; i++) {
        prefix[i] = prefix[i - 1];
        while (prefix[i] > 0 && s[i + from] != s[prefix[i] + from]) {
            prefix[i] = prefix[prefix[i] - 1];
        }
        if (s[i + from] == s[prefix[i] + from]) {
            prefix[i]++;
        }
    }
}

int main() {
    set_io();

    cin >> s;

    init();

    for (char letter : s) {
        add_letter(letter);
    }

    construct_prefix(0);

    dp.resize(sa.size(), 0);
    dfs(0);

    cout << (dp[0] - 1) << ' ';

    int cnt = dp[0] - 1;

    int q;
    cin >> q;

    int ptr = 0;

    while (q--) {
        int type;
        cin >> type;

        if (type == 1) {
            char letter;
            cin >> letter;

            s.push_back(letter);
            add_letter(letter);
            prefix.emplace_back();
            prefix[prefix.size() - 1] = prefix[prefix.size() - 2];
            while (prefix.back() > 0 && s.back() != s[prefix.back() + ptr]) {
                prefix.back() = prefix[prefix.back() - 1];
            }
            if (s.back() == s[prefix.back() + ptr]) {
                prefix.back()++;
            }
            cnt += (s.size() - ptr - prefix.back());
        } else {
            ptr++;
            init();
            for (int i = ptr; i < (int)s.size(); i++) {
                add_letter(s[i]);
            }
            prefix.clear();
            construct_prefix(ptr);
            dp.resize(sa.size());
            fill(dp.begin(), dp.end(), 0);

            dfs(0);
            cnt = dp[0];
        }

        cout << cnt << ' ';
    }

    cout << endl;

    return EXIT_SUCCESS;
}

/*
wwsgvgxjijwslkzfwicg
ceqzwdwdh
*/
